{###############################################################################
# Dipesh-MP3yk                                               Delphi-Sourcecode #
################################################################################
# by Sebastian Sauer (Dipesh)                                                  #
#   email:   mail@dipesh.de                                                    #
#   url:     www.dipesh.de                                                     #
# (C) 1999 - freeware, see the licenceagreements in readme.txt                 #
################################################################################
# MAIN.PAS - TMainForm                                                         #
# the mainform and -unit                                                       #
###############################################################################}

UNIT Main;

INTERFACE

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, ComCtrls, FileCtrl, Buttons, Menus,
     Gauges, IniFiles, ShellApi,
     MpegPlay, MpgTools, Vumeter; // Vcl-Components & Units

type
  TMainForm = class(TForm)
    PanelRight: TPanel;
    PanelLeft: TPanel;
    Splitter: TSplitter;
    MPEGPlayer: TMPEGPlayer;
    ButtonPanel: TPanel;
    OpenDialog: TOpenDialog;
    Splitter1: TSplitter;
    PanelLeftCaption: TPanel;
    PanelRightCaption: TPanel;
    ItemsPanel: TPanel;
    SaveDialog: TSaveDialog;
    ImageListBtn: TImageList;
    ListViewLeftPanel: TPanel;
    ListViewRightPanel: TPanel;
    ListViewRight: TListView;
    ItemsPanel2: TPanel;
    ButtonSelAll: TSpeedButton;
    ButtonSelNone: TSpeedButton;
    PopupMenuLeft: TPopupMenu;
    PopupMenuRight: TPopupMenu;
    PMlAddSel: TMenuItem;
    PMlAddAll: TMenuItem;
    PMlRemN: TMenuItem;
    PMlSelNone: TMenuItem;
    PMlSelGroup: TMenuItem;
    PMlSelAll: TMenuItem;
    PMrRemoveSel: TMenuItem;
    PMrRemoveAll: TMenuItem;
    N4: TMenuItem;
    PMrPlay: TMenuItem;
    PMrPause: TMenuItem;
    PMrStop: TMenuItem;
    PMrBack: TMenuItem;
    PMrNext: TMenuItem;
    ItemsPanelFlatButton: TSpeedButton;
    ItemsPanel1: TPanel;
    ButtonAddSel: TSpeedButton;
    ButtonRemoveSel: TSpeedButton;
    ButtonAddAll: TSpeedButton;
    ButtonRemoveAll: TSpeedButton;
    LeftTitleFlatButton: TSpeedButton;
    RightTitleFlatButton: TSpeedButton;
    ButtonPanelFlatButton: TSpeedButton;
    ButtonPanel1: TPanel;
    ButtonExit: TSpeedButton;
    ButtonOpen: TSpeedButton;
    ButtonPassword: TSpeedButton;
    ButtonOptions: TSpeedButton;
    ButtonAbout: TSpeedButton;
    ButtonSave: TSpeedButton;
    ButtonAddDir: TSpeedButton;
    ButtonID3Tag: TSpeedButton;
    ButtonAdd: TSpeedButton;
    GaugePanel: TPanel;
    Gauge: TGauge;
    ButtonSelInvert: TSpeedButton;
    PMlInvert: TMenuItem;
    N1: TMenuItem;
    PMlRemSel: TMenuItem;
    PMlRemAll: TMenuItem;
    MemoPanel: TPanel;
    Memo: TMemo;
    MemoFlatButton: TSpeedButton;
    AddDialog: TOpenDialog;
    ButtonSelect: TSpeedButton;
    ButtonSelGroup: TSpeedButton;
    SelectPopupMenu: TPopupMenu;
    selectnone1: TMenuItem;
    selectinvert1: TMenuItem;
    selectall1: TMenuItem;
    N2: TMenuItem;
    selectgroup1: TMenuItem;
    Vumeter: TVumeter;
    PeakTimer: TTimer;
    PlayerMainPanel: TPanel;
    SongPanel: TPanel;
    ButtonSong: TSpeedButton;
    SongFlatButton: TSpeedButton;
    PosPanel: TPanel;
    PlayerPanel: TPanel;
    PlayerPanel2: TPanel;
    ButtonBack: TSpeedButton;
    ButtonNext: TSpeedButton;
    ButtonPause: TSpeedButton;
    ButtonPlay: TSpeedButton;
    ButtonStop: TSpeedButton;
    Panel2: TPanel;
    PlayerFlutButton: TSpeedButton;
    PosFlatButton: TSpeedButton;
    ScrollBar1: TScrollBar;
    PeakPanel: TPanel;
    PeakFlatButton: TSpeedButton;
    PeakPanel2: TPanel;
    PeakButtonClear: TSpeedButton;
    PeakPanel3: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    PeakRight: TProgressBar;
    PeakLeft: TProgressBar;
    PosPanel2: TPanel;
    LabelInfo: TLabel;
    LabelNow: TLabel;
    LabelTotal: TLabel;
    ScrollBar: TScrollBar;
    ButtonRandom: TSpeedButton;
    LabelRem: TLabel;
    Panel1: TPanel;
    ListViewLeft: TListView;
    SearchPanelLeft: TPanel;
    SearchPanelRight: TPanel;
    SearchEditLeft: TEdit;
    SearchEditRight: TEdit;
    ScrollPosLabel: TLabel;
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnCreate(Sender: TObject);
    procedure OnShow(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    procedure ButtonPanel_OnResize(Sender: TObject);
    procedure PlayerPanel_OnResize(Sender: TObject);
    procedure MemoPanel_OnResize(Sender: TObject);
    procedure SearchPanelLeft_OnResize(Sender: TObject);
    procedure SearchPanelRight_OnResize(Sender: TObject);
    procedure ButtonExit_OnClick(Sender: TObject);
    procedure ButtonOpen_OnClick(Sender: TObject);
    procedure ButtonAdd_OnClick(Sender: TObject);
    procedure ButtonSave_OnClick(Sender: TObject);
    procedure SaveDialog_OnTypeChange(Sender: TObject);
    procedure ButtonAddDir_OnClick(Sender: TObject);
    procedure ButtonSelect_OnClick(Sender: TObject);
    procedure ButtonID3Tag_OnClick(Sender: TObject);
    procedure ButtonPassword_OnClick(Sender: TObject);
    procedure ButtonOptions_OnClick(Sender: TObject);
    procedure ButtonAbout_OnClick(Sender: TObject);
    procedure ListViewLeft_OnDblClick(Sender: TObject);
    procedure ListViewLeft_OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListView_OnColumnClick(Sender: TObject; Column: TListColumn);
    procedure ListViewRight_OnDblClick(Sender: TObject);
    procedure ListViewRight_OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListView_OnDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure ListView_OnDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ListView_OnChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure PopupMenuLeft_OnPopup(Sender: TObject);
    procedure PopupMenuRight_OnPopup(Sender: TObject);
    procedure SearchEditLeft_OnExit(Sender: TObject);
    procedure SearchEditRight_OnExit(Sender: TObject);
    procedure SearchEdit_OnChange(Sender: TObject);
    procedure ButtonPanelFlatButton_OnClick(Sender: TObject);
    procedure LeftTitleFlatButton_OnClick(Sender: TObject);
    procedure RightTitleFlatButton_OnClick(Sender: TObject);
    procedure ItemsPanelFlatButton_OnClick(Sender: TObject);
    procedure MemoFlatButton_OnClick(Sender: TObject);
    procedure SongFlatButton_OnClick(Sender: TObject);
    procedure PeakFlatButton_OnClick(Sender: TObject);
    procedure PosFlatButton_OnClick(Sender: TObject);
    procedure PlayerFlatButton_OnClick(Sender: TObject);
    procedure ButtonAddSel_OnClick(Sender: TObject);
    procedure ButtonRemoveSel_OnClick(Sender: TObject);
    procedure ButtonAddAll_OnClick(Sender: TObject);
    procedure ButtonRemoveAll_OnClick(Sender: TObject);
    procedure ButtonSelNone_OnClick(Sender: TObject);
    procedure ButtonSelInvert_OnClick(Sender: TObject);
    procedure ButtonSelAll_OnClick(Sender: TObject);
    procedure ButtonSelGroup_OnClick(Sender: TObject);
    procedure PMlRemSel_OnClick(Sender: TObject);
    procedure PMlRemAll_OnClick(Sender: TObject);
    procedure ButtonSong_OnClick(Sender: TObject);
    procedure ButtonPlay_OnClick(Sender: TObject);
    procedure ButtonPause_OnClick(Sender: TObject);
    procedure ButtonStop_OnClick(Sender: TObject);
    procedure ButtonBack_OnClick(Sender: TObject);
    procedure ButtonNext_OnClick(Sender: TObject);
    procedure MPEGPlayer_OnPosUpdate(Pos, Len: Integer);
    procedure MPEGPlayer_OnPlayEnd(Sender: TObject);
    procedure PeakTimer_OnTimer(Sender: TObject);
    procedure PeakButtonClear_OnClick(Sender: TObject);
    procedure ScrollBar_OnScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBar_OnChange(Sender: TObject);
  public
    function FontToString(ThisFont: TFont): string;
    function StringToFont(ThisString: string; var ToThisFont: TFont): boolean;
    function AddToSongList(ToListKind: integer; Mp3file: string; GetSongnameFromID3Tag: boolean; UseThisSongname: string): TListItem;
    procedure SetFontOrColor(SetNr: integer; SetThisFont: TFont; SetThisColor: TColor);
    procedure ExecuteCom(ExecuteStr: string; ShowState: integer; ShowErrorMsg: boolean);
    procedure ReadPlaylistfile(ThisPlaylistFileCom: string; ClearListBeforeAdding: boolean);
  protected
    procedure WndProc(var Message: TMessage); 
    procedure AppMessage(var Msg: TMsg; var Erledigt: Boolean);
    procedure WMSysCommand(var Message: TMessage); message WM_SYSCOMMAND;
    procedure ZoomMinimized;
    procedure ZoomRestore;
    procedure TrayMinimized;
    procedure TrayRestore(MakeVisibleTrue: boolean);
    procedure MsgNotAllowed;
  private
    TrayIconHandle: hWnd;
    FNotifyIconData: TNotifyIconData;
  end;

var flatButtonPanel, flatPanelLeftCaption, flatPanelRightCaption, flatItemsPanel, flatmemo,
    flatsongpanel, flatpeakpanel, flatpospanel, flatplayerpanel, PosIsChangingNow: boolean;
    mainleft, maintop, mainwidth, mainheight, mainsplitter1, mainsplitter2: integer;
    StartDir, PasswordStr: string;
    LastSongs: TStringList;
    MpgAudio: TMPEGAudio;
    MainForm: TMainForm;

const WM_SYSTRAY = WM_USER+$400;

      IniFileCom: string = 'DMP3yk.ini';
      // Player
      PlaylistFileCom: string = '';
      PlayingListItem: TListItem = nil;
      PlayRandom: boolean = true;
      PlayAutoStart: boolean = true;
      PlayAutoRemove: boolean = true;
      PlayAutoRandom: boolean = true;
      PlayUseID3Tags: boolean = true;
      PlayRemoveAfterBack: boolean = true;
      PlayThisPlaylistfileOnStart: string = '';
      SaveLastOpenPlaylistfile: boolean = false;
      PosUpdateTime: integer = 1000;
      PeakLevelUpdateTime: integer = 100;
      // Password
      IsNowProtected: boolean = false;
      NeedPwForExit: boolean = true;
      NeedPwForOpenPlaylist: boolean = true;
      NeedPwForSavePlaylist: boolean = true;
      NeedPwForAddDir: boolean = true;
      MeedPwForViewID3Tag: boolean = false;
      MeedPwForEditID3Tag: boolean = true;
      NeedPwForAddSel: boolean = false;
      NeedPwForAddAll: boolean = false;
      NeedPwForRemoveSel: boolean = false;
      NeedPwForRemoveAll: boolean = false;
      NeedPwForPlay: boolean = false;
      NeedPwForPause: boolean = false;
      NeedPwForStop: boolean = false;
      NeedPwForBack: boolean = false;
      NeedPwForNext: boolean = false;
      // Main
      singleinstance: boolean = true;
      mainwindowstate: integer = 0;
      mainzoom: boolean = true;
      maincenter: boolean = false;

function BoolToStr(BooleanWert: boolean): string;
function MilliSecondsToString(MilliSeconds: integer): string;
function GetProcent(BigInt, SmallInt: longint): integer;
function FileIsReadOnly(FileCom: string): boolean;
function ExpandFileCom(var FileCom: string; var Parameter: string): integer;
function GetLinesCount(OfTextFile: string): integer;

IMPLEMENTATION

uses AddDir, SaveHtml, ID3tag, Settings, SelGroup, About;

{$R *.DFM}          

function BoolToStr(BooleanWert: boolean): string;
begin If BooleanWert then Result:='1' else Result:='0'; end;
  
function MilliSecondsToString(MilliSeconds: integer): string;
var i1, i2: integer;
begin i1:=(MilliSeconds div 1000) div 60; i2:=(MilliSeconds div 1000)-(i1*60); Result:=FormatFloat('00',i1)+':'+FormatFloat('00',i2); end;

function GetProcent(BigInt, SmallInt: longint): integer;
var ExtReal1, ExtReal2: extended;
begin Try ExtReal1:=BigInt; ExtReal2:=SmallInt; Result:=Round((ExtReal2 * 100) / ExtReal1); Except Result:=0; end; end; 

function FileIsReadOnly(FileCom: string): boolean;
var tsr1: TSearchRec;
begin
  If FindFirst(FileCom,faAnyFile,tsr1)=0 then Result:=(tsr1.Attr and faReadOnly > 0) else Result:=false;
  FindClose(tsr1);
end;


// Expands an relative file-/directory-/Parameter-name
// Results are:
//   0 = Error: file/dir unknown
//   1 = Successfull: file found
//   2 = Successfull: directory found
//   3 = Successfull: Commandlineparams found (result in var Parameter: string)
function ExpandFileCom(var FileCom: string; var Parameter: string): integer;
var i1: integer; s1, s2, s3: string;
begin
  Result:=0; Parameter:=''; s1:=Trim(FileCom); If s1='' then Exit else If s1[1]='\' then Delete(s1,1,1);
  If FileExists(s1) then begin Result:=1; FileCom:=ExpandFileName(s1); end else
  If DirectoryExists(s1) then begin Result:=2; FileCom:=ExpandFileName(s1) end else
  If FileExists(ExtractFilePath(ParamStr(0))+s1) then begin Result:=1; FileCom:=ExtractFilePath(ParamStr(0))+s1; end else
  If DirectoryExists(ExtractFilePath(ParamStr(0))+s1) then begin Result:=2; FileCom:=ExtractFilePath(ParamStr(0))+s1; end else
  If FileExists(ParamStr(0)[1]+':\'+s1) then begin Result:=1; FileCom:=ParamStr(0)[1]+':\'+s1 end else
  If DirectoryExists(ParamStr(0)[1]+':\'+s1) then begin Result:=2; FileCom:=ParamStr(0)[1]+':\'+s1 end else begin
    i1:=Pos('|',s1); If i1<1 then Result:=0 else begin
    s2:=copy(s1,1,i1); If s2>'' then begin If s2[Length(s2)]='|' then Delete(s2,Length(s2),1); ExpandFileCom(s2,s3); end;
    Delete(s1,1,i1); If s1>'' then begin If s1[1]='|' then Delete(s1,1,1); ExpandFileCom(s1,s3); end;
    FileCom:=s2; Parameter:=s1; Result:=3;
  end; end;
end;

function GetLinesCount(OfTextFile: string): integer;
var file1: textfile;
begin
  Result:=-1; AssignFile(file1,OfTextFile); {$I-} Reset(file1); {$I+}
  If IoResult=0 then begin Result:=0; While not Eof(file1) do begin ReadLn(file1); inc(Result); end; end;
  {$I-} CloseFile(file1); {$I+}
end;

procedure TMainForm.WMSysCommand(var Message: TMessage);
begin
  Case Message.WParam of
    SC_MINIMIZE: If mainwindowstate=2 then TrayMinimized else If mainzoom then ZoomMinimized else inherited;
    SC_CLOSE: Close;
    else inherited;
  end;
end;

procedure TMainForm.ZoomMinimized;
begin Application.NormalizeTopMosts; SetActiveWindow(Application.Handle); SetWindowPos(Application.Handle,HWND_BOTTOM,Left,Top,Width,0,SWP_NOACTIVATE); ShowWindow(Application.Handle,SW_MINIMIZE); end;

procedure TMainForm.ZoomRestore;
begin SetActiveWindow(Application.Handle); ShowWindow(Application.Handle,SW_RESTORE); SetWindowPos(Application.Handle,HWND_TOP,Screen.Width div 2,Screen.Height div 2,0,0,SWP_NOACTIVATE); Application.RestoreTopMosts; end;

procedure TMainForm.TrayMinimized;
begin Visible:=false; Update; end;

procedure TMainForm.TrayRestore(MakeVisibleTrue: boolean);
begin If MakeVisibleTrue then Visible:=true; Application.BringToFront; SetActiveWindow(Application.Handle); Update; end;

procedure TMainForm.WndProc(var Message: TMessage);
begin
  With Message do Case Msg of
    WM_SYSTRAY: Case LParam of
                  WM_LBUTTONDOWN: If Visible then TrayMinimized else TrayRestore(true);
                  WM_RBUTTONDOWN: TrayRestore(not Visible);
                end
    else Result:=DefWindowProc(TrayIconHandle,Msg,wParam,lParam);
  end;
end;

procedure TMainForm.AppMessage(var Msg: TMsg; var Erledigt: Boolean);
begin
  Case Msg.Message of
    WM_SYSCOMMAND: Case Msg.wParam of
                     SC_RESTORE: If mainwindowstate=2 then begin TrayRestore(true); Erledigt:=true; end else
                                 If mainzoom then begin ZoomRestore; Erledigt:=true; end else Erledigt:=false;
                     SC_MINIMIZE: If mainwindowstate=2 then begin TrayMinimized; Erledigt:=true; end else
                                  If mainzoom then begin ZoomMinimized; Erledigt:=true; end else Erledigt:=false;
                   end;
    WM_PAINT: If mainwindowstate=2 then ShowWindow(Application.Handle,SW_HIDE); // for the trayicon (hide appsymbol)
  end;
end;

procedure TMainForm.MsgNotAllowed;
begin MessageBox(Handle,'Need first to deactivate the pw-protection.','Not allowed...',MB_IconStop+MB_Ok+MB_SetForeground); end;

// the fontstring is: "<fontcolor:integer>;<fontsize:integer>;<fontbold:bool>;<fontitalic:bool>;<fontunderline:bool>;<fontstrikeout:bool>;<fontname:string>"
function TMainForm.FontToString(ThisFont: TFont): string;
begin
  Result:=IntToStr(ThisFont.Color)+';'+IntToStr(ThisFont.Size)+';'+
          BoolToStr(fsBold in ThisFont.Style)+';'+
          BoolToStr(fsItalic in ThisFont.Style)+';'+
          BoolToStr(fsUnderline in ThisFont.Style)+';'+
          BoolToStr(fsStrikeOut in ThisFont.Style)+';'+
          ThisFont.Name;
end;

function TMainForm.StringToFont(ThisString: string; var ToThisFont: TFont): boolean;
var b1: boolean; i1, i2, i3, i4: integer; s1: string;
begin
  Result:=false; ThisString:=Trim(ThisString); If ThisString='' then Exit; i1:=1;
  Repeat
    i2:=Pos(';',ThisString);
    If i2>0 then begin s1:=copy(ThisString,1,i2-1); delete(ThisString,1,i2); ThisString:=Trim(ThisString); end else s1:=ThisString;
    b1:=true;
    Case i1 of
      1: begin Val(s1,i3,i4); If i4=0 then ToThisFont.Color:=i3; end;
      2: begin Val(s1,i3,i4); If i4=0 then ToThisFont.Size:=i3; end;
      3: begin Val(s1,i3,i4); If i4=0 then Case i3 of 0: ToThisFont.Style:=[]; 1: ToThisFont.Style:=[fsBold]; end; end;
      4: begin Val(s1,i3,i4); If i4=0 then If i3=1 then ToThisFont.Style:=ToThisFont.Style+[fsItalic]; end;
      5: begin Val(s1,i3,i4); If i4=0 then If i3=1 then ToThisFont.Style:=ToThisFont.Style+[fsUnderline]; end;
      6: begin Val(s1,i3,i4); If i4=0 then If i3=1 then ToThisFont.Style:=ToThisFont.Style+[fsStrikeOut]; end;
      7: If s1>'' then ToThisFont.Name:=s1; 
      else b1:=false;
    end;
    If b1 then inc(i1);
  until (ThisString='')or(i1>7);
  Result:=i1>7;
end;

function TMainForm.AddToSongList(ToListKind {0=leftlist 1=rightlist insertfirst 2=rightlist append}: integer; Mp3file: string; GetSongnameFromID3Tag: boolean; UseThisSongname: string): TListItem;
var b1: boolean; s1, s2: string; li1: TListItem;
begin
  Result:=nil; If not FileExists(Mp3file) then Exit; b1:=false;
  If GetSongnameFromID3Tag then begin MpgAudio.FileName:=Mp3file;
    If MpgAudio.IsValid then If MpgAudio.isTagged then begin s1:=Trim(MpgAudio.Artist);
      If (s1>'')and(Trim(MpgAudio.Title)>'') then s1:=s1+' - '+Trim(MpgAudio.Title) else
      If (s1='')and(Trim(MpgAudio.Title)>'') then s1:=Trim(MpgAudio.Title);
      If Length(s1)>0 then b1:=true;
  end; end;
  If not b1 then begin If UseThisSongname>'' then s1:=UseThisSongname else begin    
    s1:=ExtractFileName(Mp3file); s2:=ExtractFileExt(s1);
    If Length(s2)>0 then Delete(s1,Length(s1)-Length(s2)+1,Length(s2));
  end; end;
  Case ToListKind of 1: li1:=ListViewRight.Items.Insert(0); 2: li1:=ListViewRight.Items.Add; else li1:=ListViewLeft.Items.Add; end;
  li1.Caption:=s1; li1.SubItems.Add(Mp3file); Result:=li1;
  Application.ProcessMessages;
end;

procedure TMainForm.SetFontOrColor(SetNr: integer; SetThisFont: TFont; SetThisColor: TColor);
var font1: TFont;
begin
  Case SetNr of
    10: begin font1:=TFont.Create; Try // default fonts
          font1.Name:='MS Sans Serif'; font1.Size:=8; font1.Color:=clWindowText; font1.Style:=[];
          Font:=font1; ListViewLeft.Font:=font1; ListViewRight.Font:=font1; Memo.Font:=font1;
        Finally font1.Free; end; end;
    11: If SetThisFont<>nil then Font:=SetThisFont; // main-font
    12: If SetThisFont<>nil then ListViewLeft.Font:=SetThisFont; // leftlist-font
    13: If SetThisFont<>nil then ListViewRight.Font:=SetThisFont; // rightlist-font
    100: begin // default colors
           Color:=clBtnFace; ListViewLeft.Color:=clBtnFace; ListViewRight.Color:=clBtnFace; Memo.Color:=clBtnFace;
           ButtonSong.Font.Color:=clNavy; LabelInfo.Font.Color:=clNavy; LabelNow.Font.Color:=clNavy; LabelRem.Font.Color:=clNavy; LabelTotal.Font.Color:=clNavy; ScrollPosLabel.Font.Color:=clNavy;
         end;
    101: If SetThisColor>=0 then Color:=SetThisColor; // main-color
    102: If SetThisColor>=0 then ListViewLeft.Color:=SetThisColor; // leftlist-color
    103: If SetThisColor>=0 then ListViewRight.Color:=SetThisColor; // rightlist-color
    104: If SetThisColor>=0 then begin // highlighted player-color
           ButtonSong.Font.Color:=SetThisColor; LabelInfo.Font.Color:=SetThisColor; LabelNow.Font.Color:=SetThisColor; LabelRem.Font.Color:=SetThisColor; LabelTotal.Font.Color:=SetThisColor; ScrollPosLabel.Font.Color:=SetThisColor;
         end;
  end;
end;

// executes a file or dir (use "|" to split the execstring and the commandlineparams for this execstring !)
procedure TMainForm.ExecuteCom(ExecuteStr: string; ShowState: integer; ShowErrorMsg: boolean);
var s1: string; sei: TShellExecuteInfo;
begin
  s1:=''; ExpandFileCom(ExecuteStr,s1);
  With sei do begin
    FillChar(sei,SizeOf(sei),0);
    cbSize:=SizeOf(sei);
    fMask:=SEE_MASK_NOCLOSEPROCESS or SEE_MASK_FLAG_DDEWAIT or SEE_MASK_FLAG_NO_UI;
    lpFile:=PChar(ExecuteStr);
    lpDirectory:=PChar(ExtractFilePath(ExecuteStr));
    lpParameters:=PChar(s1);
    nShow:=ShowState;
  end;
  If not ShellExecuteEx(@sei) then If ShowErrorMsg then begin
    Case GetLastError of
      ERROR_FILE_NOT_FOUND: s1:='The specified file or dir was not found.';
      ERROR_PATH_NOT_FOUND: s1:='The specified path was not found.';
      ERROR_DDE_FAIL: s1:='The DDE transaction failed.';
      ERROR_NO_ASSOCIATION: s1:='There is no application associated with the given filename extension.';
      ERROR_ACCESS_DENIED: s1:='Access denied.';
      ERROR_DLL_NOT_FOUND: s1:='DLL-file not found.';
      ERROR_CANCELLED: s1:='The function prompted the user for the location of the application, but the user cancelled the request.';
      ERROR_NOT_ENOUGH_MEMORY: s1:='Not enough memory.';
      ERROR_SHARING_VIOLATION: s1:='sharing violation.';
      else s1:='unknown Error...';
    end;
    MessageBox(0,PChar(s1),'Can''t go to web...',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal);
    Exit;
  end;
end;

procedure TMainForm.ReadPlaylistfile(ThisPlaylistFileCom: string; ClearListBeforeAdding: boolean);
var b1, b2, b3: boolean; i1, i2, i3, PlaylistKind {0=None 1=Unknown 2=M3U 3=PLS}, LineCount1, Line1: integer;
    s1, s2, s3, s4, s9: string; t1: textfile;
begin
  If not FileExists(ThisPlaylistFileCom) then Exit; Update;  
  LineCount1:=GetLinesCount(ThisPlaylistFileCom);
  AssignFile(t1,ExpandFileName(ThisPlaylistFileCom)); {$I-} Reset(t1); {$I+}
  If IoResult<>0 then MessageDlg('Can''t open the chosen Playlistfile...',mtError,[mbOk],0) else begin
    Screen.Cursor:=crHourGlass;
    If ClearListBeforeAdding then ListViewLeft.Items.Clear;
    Gauge.Progress:=0; GaugePanel.Visible:=true; GaugePanel.Update; Self.Update;
    PlaylistFileCom:=ExpandFileName(ThisPlaylistFileCom);
    s1:=ExtractFilePath(PlaylistFileCom); If s1[Length(s1)]<>'\' then s1:=s1+'\';
    PlaylistKind:=0; b2:=false; b3:=false; Line1:=0; 
    While (not Eof(t1))and(not Application.Terminated) do begin
      inc(Line1); Gauge.Progress:=GetProcent(LineCount1,Line1); Gauge.Update;
      ReadLn(t1,s2); s2:=Trim(s2);
      b1:=false;
      
      If UpperCase(s2)='#EXTM3U' then PlaylistKind:=2 else
      If UpperCase(s2)='[PLAYLIST]' then PlaylistKind:=3 else
      If (Pos('#EXTINF:',UpperCase(s2))=1)and(PlaylistKind=2) then begin
        s3:=Trim(copy(s2,9,Length(s2)-8));        
        i1:=Pos(',',s3);
        If i1>0 then begin s9:=copy(s3,1,i1-1); Val(Trim(s9),i2,i3); If i3=0 then Delete(s3,1,i1); end;
        If Length(s3)>0 then b2:=true;
      end else begin
        i1:=Pos('=',s2);
        If (i1>0)and(Pos('FILE',UpperCase(s2))=1)and(PlaylistKind=3) then begin
          s4:=Trim(copy(s2,i1+1,Length(s2)-i1+1)); If Length(s4)>0 then If s4[1]='=' then begin Delete(s4,1,1); s4:=Trim(s4); end;
          If FileExists(s4) then begin s4:=ExpandFileName(s4); b3:=true; end else
          If FileExists(s1+s4) then begin s4:=s1+s4; b3:=true; end;
        end else
        If (i1>0)and(Pos('TITLE',UpperCase(s2))=1)and(PlaylistKind=3) then begin
          If b3 then begin
            delete(s2,1,i1); s2:=Trim(s2); If Length(s2)>0 then If s2[1]='=' then begin Delete(s2,1,1); s2:=Trim(s2); end;
            AddToSongList(0,s4,(PlayUseID3Tags)and(not b3),s2); b3:=false;
          end;
        end else begin
          If FileExists(s2) then begin s2:=ExpandFileName(s2); b1:=true; end else
          If FileExists(s1+s2) then begin s2:=s1+s2; b1:=true; end;
          If b1 then begin If not b2 then s3:='' else b2:=not PlayUseID3Tags; AddToSongList(0,s2,not b2,s3); b2:=false; end;
        end;        
      end;

      Application.ProcessMessages;
    end;
    GaugePanel.Visible:=false;
    Screen.Cursor:=crDefault;
  end;
  {$I-} CloseFile(t1); {$I+}
end;

{-------------------------------------------------------------------------------
Forumlar
-------------------------------------------------------------------------------}

procedure TMainForm.OnClose(Sender: TObject; var Action: TCloseAction);
var Ini1: TIniFile;
begin
  If (IsNowProtected)and(NeedPwForExit) then begin MsgNotAllowed; Action:=caNone; Exit; end;
  Case mainwindowstate of 0..2: If FileExists(IniFileCom) then begin
    Ini1:=TIniFile.Create(IniFileCom);
    Try
      If (mainwidth=-1)or(flatButtonPanel<>ButtonPanelFlatButton.Down) then Ini1.WriteBool('Main','flatButtonPanel',ButtonPanelFlatButton.Down);
      If (mainwidth=-1)or(flatPanelLeftCaption<>LeftTitleFlatButton.Down) then Ini1.WriteBool('Main','flatPanelLeftCaption',LeftTitleFlatButton.Down);
      If (mainwidth=-1)or(flatPanelRightCaption<>RightTitleFlatButton.Down) then Ini1.WriteBool('Main','flatPanelRightCaption',RightTitleFlatButton.Down);
      If (mainwidth=-1)or(flatItemsPanel<>ItemsPanelFlatButton.Down) then Ini1.WriteBool('Main','flatItemsPanel',ItemsPanelFlatButton.Down);
      If (mainwidth=-1)or(flatmemo<>MemoFlatButton.Down) then Ini1.WriteBool('Main','flatmemo',MemoFlatButton.Down);
      If (mainwidth=-1)or(flatsongpanel<>SongFlatButton.Down) then Ini1.WriteBool('Main','flatsongpanel',SongFlatButton.Down);
      If (mainwidth=-1)or(flatpeakpanel<>PeakFlatButton.Down) then Ini1.WriteBool('Main','flatpeakpanel',PeakFlatButton.Down);
      If (mainwidth=-1)or(flatpospanel<>PosFlatButton.Down) then Ini1.WriteBool('Main','flatpospanel',PosFlatButton.Down);
      If (mainwidth=-1)or(flatplayerpanel<>PlayerFlutButton.Down) then Ini1.WriteBool('Main','flatplayerpanel',PlayerFlutButton.Down);
      If SaveLastOpenPlaylistfile then If FileExists(PlaylistFileCom) then Ini1.WriteString('Playing','AutoopenPlaylist',PlayThisPlaylistfileOnStart);
      If WindowState=wsNormal then begin
        If mainleft<>left then begin mainleft:=left; Ini1.WriteInteger('Main','left',mainleft); end;
        If maintop<>top then begin maintop:=top; Ini1.WriteInteger('Main','top',maintop); end;
        If mainwidth<>width then begin mainwidth:=width; Ini1.WriteInteger('Main','width',mainwidth); end;
        If mainheight<>height then begin mainheight:=height; Ini1.WriteInteger('Main','height',mainheight); end;
      end;
      If PanelRight.Width<>mainsplitter1 then begin mainsplitter1:=PanelRight.Width; Ini1.WriteInteger('Main','splitter1',mainsplitter1); end;
      If MemoPanel.Height<>mainsplitter2 then begin
        If MemoFlatButton.Down then mainsplitter2:=StrToInt(MemoPanel.Hint) else mainsplitter2:=MemoPanel.Height;
        Ini1.WriteInteger('Main','splitter2',mainsplitter2);
      end;
      If PlayRandom<>ButtonRandom.Down then Ini1.WriteBool('Playing','Random',ButtonRandom.Down);
    Finally Ini1.Free; end;
  end; end;
  Try
    If (MPEGPlayer.Mode=plmPlaying)or(MPEGPlayer.Mode=plmPaused) then MPEGPlayer.Stop;
    Try MpgAudio.Free; Except end;
  Finally
    If mainwindowstate=2 then Shell_NotifyIcon(NIM_DELETE, @FNotifyIconData);
    DeallocateHWnd(TrayIconHandle);
  end;
end;

procedure TMainForm.OnCreate(Sender: TObject);
var i1: integer; s1: string; font1: TFont; Ini1: TIniFile;

  function ActivatePreviousInstances: boolean;
  var pc1: pchar; Handle1: THandle; Wind1: HWnd;
  begin
    Handle1:=CreateSemaphore(nil,0,1,'Dipesh-MP3yk - Semaphore');
    Result:=(Handle1<>0)and(GetLastError=ERROR_ALREADY_EXISTS);
    If Result then begin
      CloseHandle(Handle1);
      pc1:=PChar(Application.Title);
      Application.Title:='Dipesh-MP3yk - Wait...';
      Wind1:=FindWindow(nil,pc1);
      Application.Title:=pc1;
      If Wind1<>0 then begin
        PostMessage(Wind1,WM_SYSCOMMAND,SC_RESTORE,0);
        SetForegroundWindow(Wind1);
      end;
    end;
  end;

begin
  Screen.Cursor:=crHourGlass;
  Application.OnMessage:=AppMessage; TrayIconHandle:=AllocateHWnd(WndProc);
  StartDir:=ExtractFilePath(ParamStr(0)); If StartDir[Length(StartDir)]<>'\' then StartDir:=StartDir+'\';
  If not FileExists(StartDir+'Memo.txt') then begin MemoPanel.Visible:=false; Splitter1.Height:=0; end;
  If FileExists(IniFileCom) then IniFileCom:=ExpandFileName(IniFileCom) else IniFileCom:=StartDir+IniFileCom;
  Ini1:=TIniFile.Create(IniFileCom);
  Try
    // -> [Playing]
    Case Ini1.ReadInteger('Playing','Priority',-1) of 0: MPEGPlayer.PlayerPriority:=Idle; 1: MPEGPlayer.PlayerPriority:=Lowest;
      2: MPEGPlayer.PlayerPriority:=BelowNormal; 3: MPEGPlayer.PlayerPriority:=Normal; 4: MPEGPlayer.PlayerPriority:=AboveNormal;
      5: MPEGPlayer.PlayerPriority:=Highest; 6: MPEGPlayer.PlayerPriority:=TimeCritical; end;
    PlayRandom:=Ini1.ReadBool('Playing','Random',PlayRandom); ButtonRandom.Down:=PlayRandom;
    PlayAutoStart:=Ini1.ReadBool('Playing','Autostart',PlayAutoStart);
    PlayUseID3Tags:=Ini1.ReadBool('Playing','use ID3-Tag''s',PlayUseID3Tags);
    PlayAutoRemove:=Ini1.ReadBool('Playing','Autoremove',PlayAutoRemove);
    PlayAutoRandom:=Ini1.ReadBool('Playing','Autorandom',PlayAutoRandom);
    PlayRemoveAfterBack:=Ini1.ReadBool('Playing','RemoveAfterBack',PlayRemoveAfterBack);
    PlayThisPlaylistfileOnStart:=Ini1.ReadString('Playing','AutoopenPlaylist',PlayThisPlaylistfileOnStart);
    SaveLastOpenPlaylistfile:=Ini1.ReadBool('Playing','AutoopenPlaylistSave',SaveLastOpenPlaylistfile);
    // -> [Pw]
    PasswordStr:=Trim(Ini1.ReadString('Pw','Password',''));
    NeedPwForExit:=Ini1.ReadBool('Pw','Exit',NeedPwForExit);
    NeedPwForOpenPlaylist:=Ini1.ReadBool('Pw','Open Playlistfile',NeedPwForOpenPlaylist);
    NeedPwForSavePlaylist:=Ini1.ReadBool('Pw','Save Playlistfile',NeedPwForSavePlaylist);
    NeedPwForAddDir:=Ini1.ReadBool('Pw','Add dir',NeedPwForAddDir);
    MeedPwForViewID3Tag:=Ini1.ReadBool('Pw','view ID3-Tag',MeedPwForViewID3Tag);
    MeedPwForEditID3Tag:=Ini1.ReadBool('Pw','edit ID3-Tag',MeedPwForEditID3Tag);
    NeedPwForAddSel:=Ini1.ReadBool('Pw','AddSel',NeedPwForAddSel);
    NeedPwForAddAll:=Ini1.ReadBool('Pw','AddAll',NeedPwForAddAll);
    NeedPwForRemoveSel:=Ini1.ReadBool('Pw','RemoveSel',NeedPwForRemoveSel);
    NeedPwForRemoveAll:=Ini1.ReadBool('Pw','RemoveAll',NeedPwForRemoveAll);
    NeedPwForPlay:=Ini1.ReadBool('Pw','Play',NeedPwForPlay);
    NeedPwForPause:=Ini1.ReadBool('Pw','Pause',NeedPwForPause);
    NeedPwForStop:=Ini1.ReadBool('Pw','Stop',NeedPwForStop);
    NeedPwForBack:=Ini1.ReadBool('Pw','Back',NeedPwForBack);
    NeedPwForNext:=Ini1.ReadBool('Pw','Next',NeedPwForNext);
    // -> [Main]
    singleinstance:=Ini1.ReadBool('Main','singleinstance',singleinstance);
    mainwindowstate:=Ini1.ReadInteger('Main','state',mainwindowstate);
    mainzoom:=Ini1.ReadBool('Main','zoom',mainzoom);
    maincenter:=Ini1.ReadBool('Main','center',maincenter);
    If Ini1.ReadBool('Main','dragdrop',true) then begin ListViewLeft.DragMode:=dmAutomatic; ListViewRight.DragMode:=dmAutomatic; end;
    ListViewLeft.HotTrack:=Ini1.ReadBool('Main','leftlisthottrack',ListViewLeft.HotTrack);
    ListViewLeft.GridLines:=Ini1.ReadBool('Main','leftlistgridlines',ListViewLeft.GridLines);
    ListViewLeft.ShowColumnHeaders:=Ini1.ReadBool('Main','leftlistheaders',ListViewLeft.ShowColumnHeaders);
    PanelLeftCaption.Visible:=Ini1.ReadBool('Main','leftlisttitles',PanelLeftCaption.Visible);
    ListViewRight.HotTrack:=Ini1.ReadBool('Main','rightlisthottrack',ListViewRight.HotTrack);
    ListViewRight.GridLines:=Ini1.ReadBool('Main','rightlistgridlines',ListViewRight.GridLines);
    ListViewRight.ShowColumnHeaders:=Ini1.ReadBool('Main','rightlistheaders',ListViewRight.ShowColumnHeaders);
    PanelRightCaption.Visible:=Ini1.ReadBool('Main','rightlisttitles',PanelRightCaption.Visible);
    mainleft:=Ini1.ReadInteger('Main','left',60);
    maintop:=Ini1.ReadInteger('Main','top',50);
    mainwidth:=Ini1.ReadInteger('Main','width',Screen.Width-120);
    mainheight:=Ini1.ReadInteger('Main','height',Screen.Height-100);
    mainsplitter1:=Ini1.ReadInteger('Main','splitter1',-1); If mainsplitter1<0 then mainsplitter1:=PanelRight.Width;
    mainsplitter2:=Ini1.ReadInteger('Main','splitter2',82); If mainsplitter2>=0 then MemoPanel.Height:=mainsplitter2; MemoPanel.Hint:=IntToStr(MemoPanel.Height);
    flatButtonPanel:=Ini1.ReadBool('Main','flatButtonPanel',false);
    flatPanelLeftCaption:=Ini1.ReadBool('Main','flatPanelLeftCaption',false);
    flatPanelRightCaption:=Ini1.ReadBool('Main','flatPanelRightCaption',false);
    flatItemsPanel:=Ini1.ReadBool('Main','flatItemsPanel',false);
    flatmemo:=Ini1.ReadBool('Main','flatmemo',false);
    flatsongpanel:=Ini1.ReadBool('Main','flatsongpanel',false);
    flatpeakpanel:=Ini1.ReadBool('Main','flatpeakpanel',true);
    flatpospanel:=Ini1.ReadBool('Main','flatpospanel',false);
    flatplayerpanel:=Ini1.ReadBool('Main','flatplayerpanel',false);
    // -> [Style]
    font1:=TFont.Create; Try
      s1:=Ini1.ReadString('Style','mainfont',''); If StringToFont(s1,font1) then SetFontOrColor(11,font1,-1);
      i1:=Ini1.ReadInteger('Style','mainbackgrd',-1); if i1>=0 then SetFontOrColor(101,nil,i1);
      s1:=Ini1.ReadString('Style','leftlistfont',''); If StringToFont(s1,font1) then SetFontOrColor(12,font1,-1);
      i1:=Ini1.ReadInteger('Style','leftlistbackgrd',-1); if i1>=0 then SetFontOrColor(102,nil,i1);
      s1:=Ini1.ReadString('Style','rightlistfont',''); If StringToFont(s1,font1) then SetFontOrColor(13,font1,-1);
      i1:=Ini1.ReadInteger('Style','rightlistbackgrd',-1); If i1>=0 then SetFontOrColor(103,nil,i1);
      i1:=Ini1.ReadInteger('Style','playerfontcolor',-1); If i1>=0 then SetFontOrColor(104,nil,i1);
    Finally font1.Free; end;
    PosUpdateTime:=Ini1.ReadInteger('Style','scrollandpostime',PosUpdateTime); MPEGPlayer.TimerFreq:=PosUpdateTime;
    PeakLevelUpdateTime:=Ini1.ReadInteger('Style','peakleveltime',PeakLevelUpdateTime); PeakTimer.Interval:=PeakLevelUpdateTime;
  Finally Ini1.Free; end;
  If SingleInstance then If ActivatePreviousInstances then Try Free; Finally Halt; end;
  Case mainwindowstate of 0,1,2,3: begin // first set normal
    If maincenter then begin mainleft:=(Screen.Width-mainwidth) div 2; maintop:=(Screen.Height-mainheight) div 2; end;
    SetBounds(mainleft,maintop,mainwidth,mainheight);
    WindowState:=wsNormal;
    BorderStyle:=bsSizeable;
    If mainsplitter1>=0 then PanelRight.Width:=mainsplitter1 else PanelRight.Width:=(mainwidth-ItemsPanel.Width) div 2;
  end; end;
  Case mainwindowstate of // now set the other states (by default normal)
    1: PostMessage(Handle,WM_SYSCOMMAND,SC_MINIMIZE,0); // minimized
    2: begin // trayicon
         FillChar(FNotifyIconData,SizeOf(TNotifyIconData),0);
         With FNotifyIconData do begin
           cbSize:=SizeOf(TNotifyIconData);
           uID:=1;
           Wnd:=TrayIconHandle;
           uFlags:=uFlags or NIF_MESSAGE or NIF_ICON or NIF_TIP;
           StrPCopy(szTip,PChar(Application.Title));
           uCallbackMessage:=WM_SYSTRAY;
           hIcon:=Application.Icon.Handle;
         end;
         Shell_NotifyIcon(NIM_ADD,@FNotifyIconData);         
       end;
    3: WindowState:=wsMaximized; // maximized
    4: PanelRight.Width:=(Screen.Width-ItemsPanel.Width) div 2; // fullscreen
  end;
  ButtonSelGroup.Glyph:=ButtonSelect.Glyph;
  If flatButtonPanel then ButtonPanelFlatButton_OnClick(nil);
  If flatPanelLeftCaption then LeftTitleFlatButton_OnClick(nil);
  If flatPanelRightCaption then RightTitleFlatButton_OnClick(nil);
  If flatItemsPanel then ItemsPanelFlatButton_OnClick(nil);
  If flatmemo then MemoFlatButton_OnClick(nil);
  If flatsongpanel then SongFlatButton_OnClick(nil);
  If flatpeakpanel then PeakFlatButton_OnClick(nil);
  If flatpospanel then PosFlatButton_OnClick(nil);
  If flatplayerpanel then PlayerFlatButton_OnClick(nil);
end;

procedure TMainForm.OnShow(Sender: TObject);
begin If mainwindowstate=2 then ShowWindow(Application.Handle,SW_HIDE); end;

procedure TMainForm.OnActivate(Sender: TObject);
var i1: integer; s1, s2: string; CmdParamsStr: string;
begin
  If mainwindowstate=2 then ShowWindow(Application.Handle,SW_HIDE);
  If Tag=1 then begin Tag:=2;
    Update;
    LastSongs:=TStringList.Create;
    MPEGPlayer.PathToDll:=StartDir; MPEGPlayer.Init;
    MpgAudio:=TMPEGAudio.Create;
    If MemoPanel.Visible then Memo.Lines.LoadFromFile(StartDir+'Memo.txt');
    If ParamCount>0 then begin
      CmdParamsStr:='';
      For i1:=1 to ParamCount do CmdParamsStr:=CmdParamsStr+' '+ParamStr(i1);
      If ExpandFileCom(CmdParamsStr,s1)=1 then ReadPlaylistfile(CmdParamsStr,false);
    end else begin
      s1:=PlayThisPlaylistfileOnStart;
      If ExpandFileCom(s1,s2)=1 then ReadPlaylistfile(Trim(s1),false);
    end;
    Screen.Cursor:=crDefault;
  end;
end;           

procedure TMainForm.ButtonPanel_OnResize(Sender: TObject);
var i1: integer;
begin
  ButtonPanel1.Width:=ButtonPanel.Width-ButtonPanelFlatButton.Width-5;
  i1:=(ButtonPanel1.Width-4) div 10;
  ButtonExit.Width:=i1;
  ButtonOpen.SetBounds(ButtonExit.Left+i1,1,i1,ButtonExit.Height);
  ButtonAdd.SetBounds(ButtonOpen.Left+i1,1,i1,ButtonExit.Height);
  ButtonAddDir.SetBounds(ButtonAdd.Left+i1,1,i1,ButtonExit.Height);
  ButtonSave.SetBounds(ButtonAddDir.Left+i1,1,i1,ButtonExit.Height);
  ButtonSelect.SetBounds(ButtonSave.Left+i1,1,i1,ButtonExit.Height);
  ButtonID3Tag.SetBounds(ButtonSelect.Left+i1,1,i1,ButtonExit.Height);
  ButtonPassword.SetBounds(ButtonID3Tag.Left+i1,1,i1,ButtonExit.Height);
  ButtonOptions.SetBounds(ButtonPassword.Left+i1,1,i1,ButtonExit.Height);
  ButtonAbout.SetBounds(ButtonOptions.Left+i1,1,i1,ButtonExit.Height);
end;

procedure TMainForm.PlayerPanel_OnResize(Sender: TObject);
begin
  ButtonSong.Width:=SongPanel.Width-ButtonSong.Left-8;
  PosPanel2.Width:=PosPanel.Width-PosFlatButton.Width-2;
  LabelInfo.Left:=PosPanel2.Width-LabelInfo.Width-8;
  ScrollBar.Width:=PosPanel2.Width-ScrollBar.Left-32;
  ScrollPosLabel.Left:=ScrollBar.Left+ScrollBar.Width+4;
end;

procedure TMainForm.MemoPanel_OnResize(Sender: TObject);
begin MemoFlatButton.Height:=MemoPanel.Height-7; Memo.SetBounds(17,3,MemoPanel.Width-19,MemoPanel.Height-6); end;

procedure TMainForm.SearchPanelLeft_OnResize(Sender: TObject);
begin SearchEditLeft.Width:=SearchPanelLeft.Width-5; end;

procedure TMainForm.SearchPanelRight_OnResize(Sender: TObject);
begin SearchEditRight.Width:=SearchPanelRight.Width-5; end;

procedure TMainForm.ButtonExit_OnClick(Sender: TObject);
begin Close; end;

procedure TMainForm.ButtonOpen_OnClick(Sender: TObject);
begin
  If (IsNowProtected)and(NeedPwForOpenPlaylist) then begin MsgNotAllowed; Exit; end;
  With OpenDialog do begin
    If FileExists(PlaylistFileCom) then begin InitialDir:=ExtractFilePath(PlaylistFileCom); Filename:=ExtractFileName(PlaylistFileCom); end
    else begin InitialDir:=StartDir; Filename:=''; end;
    If Execute then ReadPlaylistfile(ExpandFileName(Filename),true);
  end;
end;

procedure TMainForm.ButtonAdd_OnClick(Sender: TObject);
var s1, s2, s3: string; 
begin
  If (IsNowProtected)and(NeedPwForOpenPlaylist) then begin MsgNotAllowed; Exit; end;
  With AddDialog do begin
    If FileExists(PlaylistFileCom) then InitialDir:=ExtractFilePath(PlaylistFileCom) else InitialDir:=StartDir; Filename:='';
    If Execute then begin Update;
      s1:=Trim(ExpandFileName(Filename)); s2:=LowerCase(Trim(ExtractFileExt(s1)));
      If Length(s2)>0 then begin
        If (s2='.mp1')or(s2='.mp2')or(s2='.mp3')or(s2='.mp4')or(s2='.mpg')or(s2='.mpeg') then begin // add mp3-file [*.MP3]
          s3:=ExtractFileName(s1); Delete(s3,Length(s3)-Length(s2)+1,Length(s2)+1);
          Try AddToSongList(0,s1,true,s3).MakeVisible(false); Except end;
        end else ReadPlaylistfile(s1,false); // add playlistfile [*.M3U] or [*.PLS]
      end;
    end;
  end;
end;

procedure TMainForm.ButtonSave_OnClick(Sender: TObject);
var b1, b2: boolean; i1, FileKind {0=TXT 1=M3U 2=PLS 3=Html}: integer; s1, s2: string; t1: textfile; MpegFile1: TMpegAudio;
    HtmShowCaption, HtmShowHeader: boolean;
    HtmCaptionSize, HtmCaptionAlign,
    HtmMainTextcolor, HtmMainBackcolor, HtmTableTextcolor, HtmTableBackcolor, HtmHeaderTextcolor, HtmHeaderBackcolor: Tcolor;
    HtmTabBorder, HtmTabWidth, HtmTabCellspacing, HtmTabCellpadding: integer;
    HtmTabAlign, HtmTabValign, HtmTitle: string;

  function ColorToBrowserString(ThisColor: Tcolor): string;
  begin
    Result:=ColorToString(ThisColor);
    If Length(Result)>0 then If Result[1]='$' then Result[1]:='#';
    If Length(Result)>2 then If (UpCase(Result[1])='C')and(UpCase(Result[2])='L') then Delete(Result,1,2);
  end;

begin
  If (IsNowProtected)and(NeedPwForSavePlaylist) then begin MsgNotAllowed; Exit; end;
  With SaveDialog do begin
    If FileExists(PlaylistFileCom) then begin
      InitialDir:=ExtractFilePath(PlaylistFileCom);
      s1:=ExtractFileName(PlaylistFileCom); s2:=Trim(ExtractFileExt(s1)); If Length(s2)>0 then Delete(s1,Length(s1)-Length(s2)+1,Length(s2)+1);
      Filename:=s1; DefaultExt:=Filter[FilterIndex];
    end else begin InitialDir:=StartDir; Filename:=''; end;    
    If Execute then begin b2:=true; FileKind:=0;
      If (LowerCase(Trim(ExtractFileExt(Filename)))='.htm')or(LowerCase(Trim(ExtractFileExt(Filename)))='.html') then begin // save as Html-Document
        With TSaveHtmlForm.Create(Self) do Try // extended styles for Html-Documents
          LabelFile.Caption:=LowerCase(ExpandFileName(Filename));
          i1:=ShowModal;
          If i1=mrOk then begin FileKind:=3;
            HtmTitle:=EditTitle.Text; HtmShowCaption:=CheckBoxCaption.Checked;
            HtmCaptionSize:=ComboBoxCaptionSize.ItemIndex; HtmCaptionAlign:=ComboBoxCaptionAlign.ItemIndex;
            HtmMainTextcolor:=MainColorsPanel.Font.Color; HtmMainBackcolor:=MainColorsPanel.Color;
            HtmTableTextcolor:=TableColorsPanel.Font.Color; HtmTableBackcolor:=TableColorsPanel.Color;
            HtmHeaderTextcolor:=HeaderColorPanel.Font.Color; HtmHeaderBackcolor:=HeaderColorPanel.Color;
            HtmShowHeader:=CheckBoxShowHeader.Checked;
            HtmTabBorder:=TableBorderUpDown.Position; HtmTabWidth:=TableWidthUpDown.Position;
            HtmTabCellspacing:=TableCellspacingUpDown.Position; HtmTabCellpadding:=TableCellpaddingUpDown.Position;
            Case TableAlignComboBox.ItemIndex of 1: HtmTabAlign:='center'; 2: HtmTabAlign:='right'; else HtmTabAlign:='left'; end;
            Case TableValignComboBox.ItemIndex of 0: HtmTabValign:='top'; 2: HtmTabValign:='bottom'; else HtmTabValign:='center'; end;
          end;
        Finally Free; end;
        If i1<>mrOk then Exit; // abort, don't save anything
      end; 
      AssignFile(t1,ExpandFileName(Filename)); {$I-} Rewrite(t1); {$I+}
      If IoResult<>0 then begin b1:=false; MessageBox(Handle,'Can''t write the chosen file...','Write-Error',MB_IconError+MB_Ok+MB_SetForeground) end else begin
        Screen.Cursor:=crHourGlass; Gauge.Progress:=0; GaugePanel.Visible:=true; GaugePanel.Update; Self.Update; b1:=true;
        If LowerCase(Trim(ExtractFileExt(Filename)))='.m3u' then begin // EXTM3U-header
          b2:=not PlayUseID3Tags;
          FileKind:=1; PlaylistFileCom:=ExpandFileName(Filename);
          WriteLn(t1,'#EXTM3U');
        end else
        If LowerCase(Trim(ExtractFileExt(Filename)))='.pls' then begin // PLS-header
          FileKind:=2; PlaylistFileCom:=ExpandFileName(Filename);
          WriteLn(t1,'[playlist]');
        end else
        If (LowerCase(Trim(ExtractFileExt(Filename)))='.htm')or(LowerCase(Trim(ExtractFileExt(Filename)))='.html')or(FileKind=3) then begin // HTML-header
          FileKind:=3;
          WriteLn(t1,'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">');
          WriteLn(t1,'<html>');
          WriteLn(t1,'<head>'); WriteLn(t1,'<title>'+HtmTitle+'</title>'); WriteLn(t1,'</head>');
          WriteLn(t1,'<body text="'+ColorToBrowserString(HtmMainTextcolor)+'" bgcolor="'+ColorToBrowserString(HtmMainBackcolor)+'">');
          If HtmShowCaption then begin
            Case HtmCaptionAlign of 0: WriteLn(t1,'<div align=left>'); 2: WriteLn(t1,'<div align=right>'); else WriteLn(t1,'<div align=center>'); end;
            WriteLn(t1,'  <h'+IntToStr(HtmCaptionSize+1)+'>'+HtmTitle+'</h'+IntToStr(HtmCaptionSize+1)+'>');
            WriteLn(t1,'</div>');
          end;
          WriteLn(t1,'<div align=center>');
          WriteLn(t1,'  <table border='+IntToStr(HtmTabBorder)+' cellpadding='+IntToStr(HtmTabCellpadding)+' cellspacing='+IntToStr(HtmTabCellspacing)+' width="'+IntToStr(HtmTabWidth)+'%">');
          If HtmShowHeader then begin
            WriteLn(t1,'    <tr align='+HtmTabAlign+' valign='+HtmTabValign+' bgcolor="'+ColorToBrowserString(HtmHeaderBackcolor)+'"> <td>');
            WriteLn(t1,'      <font color="'+ColorToBrowserString(HtmHeaderTextcolor)+'">');
            WriteLn(t1,'        '+HtmTitle);
            WriteLn(t1,'      </font>');
            WriteLn(t1,'    </td> </tr>');
          end;
        end else FileKind:=0; // none header for textfiles
        MpegFile1:=TMpegAudio.Create;
        Try
          For i1:=0 to pred(ListViewLeft.Items.Count) do If FileExists(ListViewLeft.Items[i1].SubItems[0]) then begin
            Gauge.Progress:=GetProcent(pred(ListViewLeft.Items.Count),i1); Gauge.Update;
            Case FileKind of
              1: Try // save as EXTM3U-Playlist
                   If b2 then WriteLn(t1,'#EXTINF:0,'+ListViewLeft.Items[i1].Caption) else begin
                     MpegFile1.Filename:=ListViewLeft.Items[i1].SubItems[0];
                     WriteLn(t1,'#EXTINF:'+FormatFloat('#000',MpegFile1.Duration)+','+ListViewLeft.Items[i1].Caption);
                   end;
                   WriteLn(t1,ListViewLeft.Items[i1].SubItems[0]);
                 Except; end;
              2: begin // save as PLS-Playlist
                   WriteLn(t1,'File'+IntToStr(i1+1)+'='+ListViewLeft.Items[i1].SubItems[0]);
                   WriteLn(t1,'Title'+IntToStr(i1+1)+'='+ListViewLeft.Items[i1].Caption);
                 end;
              3: begin // save as Html-Document
                   WriteLn(t1,'    <tr align='+HtmTabAlign+' valign='+HtmTabValign+' bgcolor="'+ColorToBrowserString(HtmTableBackcolor)+'"> <td>');
                   WriteLn(t1,'      <font color="'+ColorToBrowserString(HtmTableTextcolor)+'">');
                   WriteLn(t1,'        '+ListViewLeft.Items[i1].Caption);
                   WriteLn(t1,'      </font>');
                   WriteLn(t1,'    </td> </tr>');
                 end;
              else WriteLn(t1,ListViewLeft.Items[i1].Caption); // save as textfile
            end;
          end;
        Finally MpegFile1.Free; end;
        Case FileKind of
          2: begin // write endheader for PLS-files
               WriteLn(t1,'NumberOfEntries='+IntToStr(ListViewLeft.Items.Count)); WriteLn(t1,'Version=2');
             end;
          3: begin // write end of Html-Document
               WriteLn(t1,'  </table>'); WriteLn(t1,'</div>'); WriteLn(t1,'</body>'); WriteLn(t1,'</html>');
             end;
        end;
        GaugePanel.Visible:=false; Screen.Cursor:=crDefault;
      end;
      {$I-} CloseFile(t1); {$I+}
      If (IoResult<>0)and(b1) then MessageBox(Handle,'Can''t write into the chosen file...','Save-Error',MB_IconError+MB_Ok+MB_SetForeground);
    end;
  end;
end;

procedure TMainForm.SaveDialog_OnTypeChange(Sender: TObject);
begin If SaveDialog.FilterIndex=1 then SaveDialog.DefaultExt:='txt' else SaveDialog.DefaultExt:='m3u'; end;

procedure TMainForm.ButtonAddDir_OnClick(Sender: TObject);
var s1: string;

  procedure ReadDirContens(sDir,sName: string; ReadID3TagsForSongnames, RecursivInclSubdirs: boolean);
  var DosError: integer; tsr1: TSearchRec;
  begin
    If sDir>'' then If sDir[Length(sDir)]<>'\' then sDir:=sDir+'\';
    DosError:=FindFirst(sDir+sName,faAnyFile mod faDirectory,tsr1); // first read files
    While (DosError=0)and(not Application.Terminated) do begin
      MainForm.AddToSongList(0,sDir+tsr1.name,ReadID3TagsForSongnames,'');
      Application.ProcessMessages;
      DosError:=FindNext(tsr1);
      Application.ProcessMessages;
    end;
    FindClose(tsr1);
    If RecursivInclSubdirs then begin // than read directories if it should read recursive (incl. all subdirs)
      DosError:=FindFirst(sDir+'*.*',faDirectory,tsr1);
      While (DosError=0)and(not Application.Terminated) do begin
        If (tsr1.Attr and faDirectory=faDirectory) and (tsr1.Name[1]<>'.') then begin
          ReadDirContens(sDir+tsr1.Name,sName,ReadID3TagsForSongnames,RecursivInclSubdirs); // recursive!
        end;
        DosError:=FindNext(tsr1);
        Application.ProcessMessages;
      end;
      FindClose(tsr1);
    end;
  end;

begin
  If (IsNowProtected)and(NeedPwForAddDir) then begin MsgNotAllowed; Exit; end;
  With TAddDirForm.Create(Self) do Try If ShowModal=mrOk then begin Screen.Cursor:=crHourGlass;
    If CheckBoxClear.Checked then MainForm.ListViewLeft.Items.Clear;
    s1:=Trim(ComboBoxFilter.Text); If s1='' then s1:='*.*';
    ReadDirContens(EditDir.Text,s1,CheckBoxID3Tags.Checked,CheckBoxRecursiv.Checked);
    If CheckBoxSort.Checked then ListView_OnColumnClick(ListViewLeft,ListViewLeft.Columns[0]);    
  end; Finally Free; Screen.Cursor:=crDefault; end;
end;

procedure TMainForm.ButtonSelect_OnClick(Sender: TObject);
var tp1: TPoint;
begin
  tp1.X:=ButtonSelect.Left; tp1.Y:=ButtonSelect.Top+ButtonSelect.Height;
  tp1:=ButtonPanel1.ClientToScreen(tp1); SelectPopupMenu.Popup(tp1.X,tp1.Y);
end;

procedure TMainForm.ButtonID3Tag_OnClick(Sender: TObject);
begin
  If (IsNowProtected)and(MeedPwForViewID3Tag) then begin MsgNotAllowed; Exit; end;
  If ActiveControl=ListViewLeft then begin
    If ListViewLeft.Selected=nil then Exit else begin ID3TagForm_TitleStr:=ListViewLeft.Selected.Caption; ID3TagForm_MpgFileCom:=ListViewLeft.Selected.SubItems[0]; end;
  end else
  If ActiveControl=ListViewRight then begin
    If ListViewRight.Selected=nil then Exit else begin ID3TagForm_TitleStr:=ListViewRight.Selected.Caption; ID3TagForm_MpgFileCom:=ListViewRight.Selected.SubItems[0]; end;
  end else Exit;
  With TID3TagForm.Create(Self) do Try ShowModal; Finally Free; end;
end;

procedure TMainForm.ButtonPassword_OnClick(Sender: TObject);
var s1: string;
begin
  If (PasswordStr='') then begin
    ButtonPassword.Down:=false;
    MessageBox(Handle,PChar('None pw is given.'+#13+'Go to the Options to enter password.'),'Protection is disabled...',MB_IconInformation+MB_Ok+MB_SetForeground);
    Exit;
  end;
  If IsNowProtected then begin
    If InputQuery('Passwordprotection','Enter the whole password:',s1) then begin
      If s1=PasswordStr then begin
        ButtonPassword.Down:=false; IsNowProtected:=false;
      end else begin ButtonPassword.Down:=true; IsNowProtected:=true; end;
    end else begin ButtonPassword.Down:=true; IsNowProtected:=true; end;
  end else begin ButtonPassword.Down:=true; IsNowProtected:=true; end;
end;

procedure TMainForm.ButtonOptions_OnClick(Sender: TObject);
begin
  If IsNowProtected then begin MsgNotAllowed; Exit; end;
  With TSettingsForm.Create(Self) do Try ShowModal; Finally Free; end;
end;

procedure TMainForm.ButtonAbout_OnClick(Sender: TObject);
begin With TAboutForm.Create(Self) do Try ShowModal; Finally Free; end; end;

procedure TMainForm.ListViewLeft_OnDblClick(Sender: TObject);
var li1: TListItem;
begin
  If ListViewLeft.Selected<>nil then begin
    li1:=ListViewRight.Items.Add;
    li1.Caption:=ListViewLeft.Selected.Caption;
    li1.SubItems.Add(ListViewLeft.Selected.SubItems[0]);
    ListViewRight.Selected:=li1;
    ListViewRight.Selected.MakeVisible(false);
    If PlayAutoStart then If MPEGPlayer.Mode<>plmPlaying then ButtonPlay_OnClick(nil);
  end;
end;

procedure TMainForm.ListViewLeft_OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  If Shift=[] then Case Key of
    13: ButtonAddSel_OnClick(nil); // [Enter]
    106: ButtonSelAll_OnClick(nil); // Num[*]
    107: ButtonSelInvert_OnClick(nil); // Num[+]
    109: ButtonSelNone_OnClick(nil); // Num[-]
    112: ButtonAbout_OnClick(nil); // [F1]
    113: ButtonOpen_OnClick(nil); // [F2]
    114: ButtonAdd_OnClick(nil); // [F3]
    115: ButtonAddDir_OnClick(nil); // [F4]
    116: ButtonSave_OnClick(nil); // [F5]
    119: ButtonID3Tag_OnClick(nil); // [F8]
    120: ButtonPassword_OnClick(nil); // [F9]
    121: ButtonOptions_OnClick(nil); // [F10]
    48..90: If Sender=ListViewRight then begin // [0..9] and [a..z] in right list
              SearchEditRight.Text:=Char(Key); SearchPanelRight.Visible:=true;
              ActiveControl:=SearchEditRight; SearchEditRight.SelStart:=1;
            end else begin // [0..9] and [a..z] in left list
              SearchEditLeft.Text:=Char(Key); SearchPanelLeft.Visible:=true;
              ActiveControl:=SearchEditLeft; SearchEditLeft.SelStart:=1;
            end;
    // else messagedlg('keycode: '+inttostr(key),mtinformation,[mbok],0);
  end;
end;

procedure TMainForm.ListViewRight_OnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  If Shift=[] then Case Key of
    13: ListViewRight_OnDblClick(nil); // [Enter]
    else ListViewLeft_OnKeyDown(Sender,Key,Shift);
  end;
end;

function DoColumnSort(Item1, Item2: TListItem; Col: integer): integer; StdCall;
var s1, s2: string;
begin
  Case Col of 0: begin s1:=Item1.Caption; s2:=Item2.Caption; end;
    else If (Item1.SubItems.Count>=Col)and(Item2.SubItems.Count>=Col) then begin s1:=Item1.SubItems[Col-1]; s2:=Item2.SubItems[Col-1]; end; end;
  Result:=lstrcmp(pchar(s1),pchar(s2));
end;

procedure TMainForm.ListView_OnColumnClick(Sender: TObject; Column: TListColumn);
var lv1: TListView;
begin lv1:=(Sender as TListView); lv1.CustomSort(@DoColumnSort,Column.Index); end;

procedure TMainForm.ListView_OnDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin Accept:=(Source=ListViewLeft)or(Source=ListViewRight); end;

procedure TMainForm.ListView_OnDragDrop(Sender, Source: TObject; X, Y: Integer);
var i1: integer; li1, li2: TListItem;
begin
  li1:=(Sender as TListView).GetItemAt(X,Y); 
  If (Sender=ListViewLeft)and(Source=ListViewLeft) then begin // inside ListViewLeft
    For i1:=pred(ListViewLeft.Items.Count) downto 0 do If ListViewLeft.Items[i1].Selected then begin
      ListViewLeft.Items[i1].Selected:=false; li2:=ListViewLeft.Items[i1];
      If li1=nil then li1:=ListViewLeft.Items.Add else li1:=ListViewLeft.Items.Insert(li1.Index);
      li1.Caption:=li2.Caption; li1.SubItems.Add(li2.SubItems[0]);
      li1.Selected:=true; li2.Delete;
    end;    
  end else
  If (Sender=ListViewRight)and(Source=ListViewRight)and(ListViewRight.Selected<>nil) then begin // inside ListViewRight
    li2:=ListViewRight.Selected;
    If li1=nil then li1:=ListViewRight.Items.Add else li1:=ListViewRight.Items.Insert(li1.Index);
    li1.Caption:=li2.Caption; li1.SubItems.Add(li2.SubItems[0]);
    If li2=PlayingListItem then PlayingListItem:=li1;
    li2.Delete;
    ListViewRight.Selected:=li1; li1.MakeVisible(false);
  end else
  If (Sender=ListViewLeft)and(Source=ListViewRight) then begin // from ListViewRight to ListViewLeft
    ButtonRemoveSel_OnClick(nil); li1.MakeVisible(false);
  end else
  If (Sender=ListViewRight)and(Source=ListViewLeft) then begin // from ListViewLeft to ListViewRight
    If (IsNowProtected)and(NeedPwForAddSel) then begin MsgNotAllowed; Exit; end;
    For i1:=pred(ListViewLeft.Items.Count) downto 0 do If ListViewLeft.Items[i1].Selected then begin
      If li1=nil then li1:=ListViewRight.Items.Add else li1:=ListViewRight.Items.Insert(li1.Index);
      li1.Caption:=ListViewLeft.Items[i1].Caption; li1.SubItems.Add(ListViewLeft.Items[i1].SubItems[0]);
    end;
    ListViewRight.Selected:=li1; li1.MakeVisible(false);
  end;
end;

procedure TMainForm.ListView_OnChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  If ListViewRight.Selected<>nil then begin
    If not ButtonPlay.Enabled then ButtonPlay.Enabled:=true;
    If (ListViewRight.Items[ListViewRight.Selected.Index-1]<>nil)or(LastSongs.Count>1) then begin
      If not ButtonBack.Enabled then ButtonBack.Enabled:=true
    end else If ButtonBack.Enabled then ButtonBack.Enabled:=false;
    If ((ListViewRight.Selected<>nil)and(ListViewRight.Items.Count=1))or(ListViewRight.Items[ListViewRight.Selected.Index+1]<>nil) then begin
      If not ButtonNext.Enabled then ButtonNext.Enabled:=true;
    end else If ButtonNext.Enabled then ButtonNext.Enabled:=false;    
  end else begin
    If ButtonPlay.Enabled then ButtonPlay.Enabled:=false;
    If LastSongs.Count>1 then begin If not ButtonBack.Enabled then ButtonBack.Enabled:=true;
    end else begin If ButtonBack.Enabled then ButtonBack.Enabled:=false; end;
    If ListViewLeft.Items.Count>0 then begin If not ButtonNext.Enabled then ButtonNext.Enabled:=true; end else
    If ButtonNext.Enabled then ButtonNext.Enabled:=false;
  end;  
end;

procedure TMainForm.PopupMenuLeft_OnPopup(Sender: TObject);
begin
  PMlAddSel.Enabled:=ListViewLeft.SelCount>0; PMlAddAll.Enabled:=ListViewLeft.Items.Count>0;
  PMlSelNone.Enabled:=ListViewLeft.Items.Count>0; PMlInvert.Enabled:=ListViewLeft.Items.Count>0;
  PMlSelAll.Enabled:=ListViewLeft.Items.Count>0; PMlSelGroup.Enabled:=ListViewLeft.Items.Count>0;
  PMlRemN.Visible:=(ListViewLeft.Items.Count>0)and(not((IsNowProtected)and(NeedPwForAddDir)));
  PMlRemSel.Visible:=(ListViewLeft.Items.Count>0)and(not((IsNowProtected)and(NeedPwForAddDir)));
  PMlRemAll.Visible:=(ListViewLeft.Items.Count>0)and(not((IsNowProtected)and(NeedPwForAddDir)));
end;

procedure TMainForm.PopupMenuRight_OnPopup(Sender: TObject);
begin
  PMrRemoveSel.Enabled:=ListViewRight.Selected<>nil; PMrRemoveAll.Enabled:=ListViewRight.Selected<>nil;
  PMrPlay.Enabled:=ButtonPlay.Enabled; PMrPause.Enabled:=ButtonPause.Enabled; PMrStop.Enabled:=ButtonStop.Enabled;
  PMrBack.Enabled:=ButtonBack.Enabled; PMrNext.Enabled:=ButtonNext.Enabled;
end;

procedure TMainForm.SearchEditLeft_OnExit(Sender: TObject);
begin SearchPanelLeft.Visible:=false; end;

procedure TMainForm.SearchEditRight_OnExit(Sender: TObject);
begin SearchPanelRight.Visible:=false; end;

procedure TMainForm.SearchEdit_OnChange(Sender: TObject);
var li1: TListItem;
begin
  li1:=ListViewLeft.FindCaption(0,(Sender as TEdit).Text,true,true,false);
  If li1<>nil then begin
    ButtonSelNone_OnClick(nil);
    ListViewLeft.Selected:=li1;
    li1.MakeVisible(false);
  end;
end;

procedure TMainForm.ButtonPanelFlatButton_OnClick(Sender: TObject);
begin
  If ButtonPanel1.Visible then begin ButtonPanel1.Visible:=false; ButtonPanel.Height:=12; ButtonPanelFlatButton.Height:=6; ButtonPanelFlatButton.Down:=true;
  end else begin ButtonPanel.Height:=49; ButtonPanelFlatButton.Height:=42; ButtonPanel1.Visible:=true; ButtonPanelFlatButton.Down:=false; end;
end;

procedure TMainForm.LeftTitleFlatButton_OnClick(Sender: TObject);
begin
  If PanelLeftCaption.Caption='' then begin PanelLeftCaption.Caption:=PanelLeftCaption.Hint; PanelLeftCaption.Height:=21; LeftTitleFlatButton.Height:=17; LeftTitleFlatButton.Down:=false;
  end else begin PanelLeftCaption.Caption:=''; PanelLeftCaption.Height:=10; LeftTitleFlatButton.Height:=6; LeftTitleFlatButton.Down:=true; end;
end;

procedure TMainForm.RightTitleFlatButton_OnClick(Sender: TObject);
begin
  If PanelRightCaption.Caption='' then begin PanelRightCaption.Caption:=PanelRightCaption.Hint; PanelRightCaption.Height:=21; RightTitleFlatButton.Height:=17; RightTitleFlatButton.Down:=false;
  end else begin PanelRightCaption.Caption:=''; PanelRightCaption.Height:=10; RightTitleFlatButton.Height:=6; RightTitleFlatButton.Down:=true; end;
end;

procedure TMainForm.ItemsPanelFlatButton_OnClick(Sender: TObject);
begin
  If ItemsPanel1.Visible then begin ItemsPanel1.Visible:=false; ItemsPanel2.Visible:=false; ItemsPanel.Width:=8; ItemsPanelFlatButton.Width:=6; ItemsPanelFlatButton.Down:=true;
  end else begin ItemsPanel1.Visible:=true; ItemsPanel2.Visible:=true; ItemsPanel.Width:=29; ItemsPanelFlatButton.Width:=27; ItemsPanelFlatButton.Down:=false; end;
end;

procedure TMainForm.MemoFlatButton_OnClick(Sender: TObject);
begin
  If Memo.Visible then begin MemoPanel.Hint:=IntToStr(MemoPanel.Height); Memo.Visible:=false; MemoPanel.Height:=12; MemoFlatButton.Down:=true;
  end else begin MemoPanel.Height:=StrToInt(MemoPanel.Hint); Memo.Visible:=true; MemoFlatButton.Down:=false; end;
end;

procedure TMainForm.SongFlatButton_OnClick(Sender: TObject);
begin
  If ButtonSong.Visible then begin ButtonSong.Visible:=false; SongPanel.Height:=8; SongFlatButton.Height:=6; SongFlatButton.Down:=true;
  end else begin ButtonSong.Visible:=true; SongPanel.Height:=21; SongFlatButton.Height:=20; SongFlatButton.Down:=false; end;
  PlayerMainPanel.Height:=SongPanel.Height+PeakPanel.Height+PosPanel.Height+PlayerPanel.Height+2;
end;

procedure TMainForm.PeakFlatButton_OnClick(Sender: TObject);
begin
  If PeakPanel2.Visible then begin
    PeakPanel2.Visible:=false; PeakPanel.Height:=8; PeakFlatButton.Height:=6; PeakFlatButton.Down:=true;
    If PeakTimer.Enabled then begin PeakTimer.Enabled:=false; Vumeter.Stop; end;
  end else begin
    PeakPanel2.Visible:=true; PeakPanel.Height:=26; PeakFlatButton.Height:=24; PeakFlatButton.Down:=false;
    If not PeakTimer.Enabled then begin Vumeter.Start; PeakTimer_OnTimer(nil); PeakTimer.Enabled:=true; end;
  end;
  PlayerMainPanel.Height:=SongPanel.Height+PeakPanel.Height+PosPanel.Height+PlayerPanel.Height+2;
end;

procedure TMainForm.PosFlatButton_OnClick(Sender: TObject);
begin
  If PosPanel2.Visible then begin PosPanel2.Visible:=false; PosPanel.Height:=8; PosFlatButton.Height:=6; PosFlatButton.Down:=true;
  end else begin PosPanel2.Visible:=true; PosPanel.Height:=32; PosFlatButton.Height:=32; PosFlatButton.Down:=false; end;
  PlayerMainPanel.Height:=SongPanel.Height+PeakPanel.Height+PosPanel.Height+PlayerPanel.Height+2;
end;

procedure TMainForm.PlayerFlatButton_OnClick(Sender: TObject);
begin
  If PlayerPanel2.Visible then begin PlayerPanel2.Visible:=false; PlayerPanel.Height:=8; PlayerFlutButton.Height:=6; PlayerFlutButton.Down:=true;
  end else begin PlayerPanel2.Visible:=true; PlayerPanel.Height:=44; PlayerFlutButton.Height:=42; PlayerFlutButton.Down:=false; end;
  PlayerMainPanel.Height:=SongPanel.Height+PeakPanel.Height+PosPanel.Height+PlayerPanel.Height+2;
end;

procedure TMainForm.ButtonAddSel_OnClick(Sender: TObject);
var i1: integer; li1: TListItem;
begin
  If ListViewLeft.SelCount<1 then Exit;
  If (IsNowProtected)and(NeedPwForAddSel) then begin MsgNotAllowed; Exit; end;
  For i1:=0 to pred(ListViewLeft.Items.Count) do If ListViewLeft.Items[i1].Selected then begin
    li1:=ListViewRight.Items.Add;
    li1.Caption:=ListViewLeft.Items[i1].Caption;
    li1.SubItems.Add(ListViewLeft.Items[i1].SubItems[0]);
  end;
end;

procedure TMainForm.ButtonRemoveSel_OnClick(Sender: TObject);
var li1: TListItem;
begin
  If ListViewRight.Selected=nil then Exit;
  If (IsNowProtected)and(NeedPwForRemoveSel) then begin MsgNotAllowed; Exit; end;  
  With ListViewRight do Try
    li1:=Selected;
    If Items[Selected.Index+1]<>nil then Selected:=Items[Selected.Index+1] else
    If Items[Selected.Index-1]<>nil then Selected:=Items[Selected.Index-1];
    If PlayingListItem=li1 then ButtonStop_OnClick(nil);
    li1.Delete;
  Except end;
  ListView_OnChange(nil,nil,ctState);
end;

procedure TMainForm.ButtonAddAll_OnClick(Sender: TObject);
begin
  If ListViewLeft.Items.Count<1 then Exit;
  If (IsNowProtected)and(NeedPwForAddAll) then begin MsgNotAllowed; Exit; end;
  If MessageBox(Handle,'Really add all avaible songs to the list?','Add all?',MB_IconQuestion+MB_OkCancel+MB_SetForeground)<>idOk then Exit;
  ButtonSelAll_OnClick(nil); ButtonAddSel_OnClick(nil);
end;

procedure TMainForm.ButtonRemoveAll_OnClick(Sender: TObject);
begin
  If ListViewRight.Items.Count<1 then Exit;
  If (IsNowProtected)and(NeedPwForRemoveAll) then begin MsgNotAllowed; Exit; end;
  If MessageBox(Handle,'Really remove all songs from the list?','Remove all?',MB_IconQuestion+MB_OkCancel+MB_SetForeground)<>idOk then Exit;
  If PlayingListItem<>nil then ButtonStop_OnClick(nil);
  ListViewRight.Items.Clear;
  ListView_OnChange(nil,nil,ctState);
end;

procedure TMainForm.ButtonSelNone_OnClick(Sender: TObject);
var i1: integer;
begin
  If ListViewLeft.Selected<>nil then ListViewLeft.Selected.Selected:=false;
  If ListViewLeft.SelCount>0 then 
    For i1:=0 to pred(ListViewLeft.Items.Count) do If ListViewLeft.Items[i1].Selected then ListViewLeft.Items[i1].Selected:=false;
end;

procedure TMainForm.ButtonSelInvert_OnClick(Sender: TObject);
var i1: integer;
begin For i1:=0 to pred(ListViewLeft.Items.Count) do ListViewLeft.Items[i1].Selected:=not ListViewLeft.Items[i1].Selected; end;

procedure TMainForm.ButtonSelAll_OnClick(Sender: TObject);
var i1: integer;
begin For i1:=0 to pred(ListViewLeft.Items.Count) do If not ListViewLeft.Items[i1].Selected then ListViewLeft.Items[i1].Selected:=true; end;

procedure TMainForm.ButtonSelGroup_OnClick(Sender: TObject);
var b1, b2: boolean; sSongname, sFilename, s1: string; i1, i8, i9, i10: integer; snList, fnList: TStringList; MpegFile1: TMpegAudio;

  procedure DeleteChars(var FromThisString: string; DelSpecialChars, DelNummericChars: boolean);
  var laufvar1, pos1: integer;
  const SpecialChars: array[0..30] of char = (' ','-','.',':',';','_','#','+','*','~','''',',','\','/','?','(',
                                              ')',']','[','{','}','=','&','%','$','','"','!','<','>','|');
        NummericChars: array[0..9] of char = ('0','1','2','3','4','5','6','7','8','9');
  begin
    If DelSpecialChars then For laufvar1:=0 to 30 do
      Repeat pos1:=Pos(SpecialChars[laufvar1],FromThisString); If pos1>0 then Delete(FromThisString,pos1,1); until pos1<1;
    If DelNummericChars then For laufvar1:=0 to 9 do
      Repeat pos1:=Pos(NummericChars[laufvar1],FromThisString); If pos1>0 then Delete(FromThisString,pos1,1); until pos1<1;
  end;

begin
  If ListViewLeft.Items.Count<1 then Exit;
  With TSelGroupForm.Create(Self) do Try
    If ShowModal=mrOk then Try Screen.Cursor:=crHourGlass;
      Gauge.Progress:=0; GaugePanel.Visible:=true; GaugePanel.Update; Self.Update;
      Self.ActiveControl:=ListViewLeft;
      If CheckBoxClear.Checked then ButtonSelNone_OnClick(nil);
      If CheckBoxOnlyDuplicates.Checked then begin
        snList:=TStringList.Create; fnList:=TStringList.Create;
      end else begin
        sSongname:=Trim(ComboBoxSongname.Text); sFilename:=Trim(ComboBoxFilename.Text);
        If not CheckBoxSongnameCaseSensitive.Checked then begin sSongname:=LowerCase(sSongname); sFilename:=LowerCase(sFilename); end;
      end;

      For i1:=0 to pred(Self.ListViewLeft.Items.Count) do Try
        Self.Gauge.Progress:=GetProcent(pred(Self.ListViewLeft.Items.Count),i1); Self.Gauge.Update;
        If not Self.ListViewLeft.Items[i1].Selected then begin
          b1:=true; // if following code don't make them false, the item will be selected (FALSE = no more search required!)

          If CheckBoxOnlyDuplicates.Checked then begin  // selected only duplicate songs
          
            If (CheckBoxDupSongname.Checked)and(b1) then begin // songname
              sSongname:=Trim(Self.ListViewLeft.Items[i1].Caption);
              If not CheckBoxDupCaseSensitive.Checked then sSongname:=LowerCase(sSongname);
              DeleteChars(sSongname,CheckBoxDupIgnoreSpecials.Checked,CheckBoxDupIgnoreNrs.Checked);                   
              i8:=0; b2:=false;
              While (not b2)and(i8<snList.Count) do begin
                s1:=snList[i8];
                If CheckBoxDupWholeSongname.Checked then begin If s1=sSongname then b2:=true; end else begin
                  i9:=Pos(sSongname,s1); i10:=Pos(s1,sSongname); If (i9>0)or(i10>0) then b2:=true; end;
                inc(i8);
              end;
              b1:=b2; snList.Add(sSongname);
            end;
            If (CheckBoxDupFilename.Checked)and(b1) then begin // filename
              sFilename:=LowerCase(ExtractFileName(Trim(Self.ListViewLeft.Items[i1].SubItems[0])));
              DeleteChars(sFilename,CheckBoxDupIgnoreSpecials.Checked,CheckBoxDupIgnoreNrs.Checked);
              i8:=0; b2:=false;
              While (not b2)and(i8<fnList.Count) do begin
                s1:=LowerCase(ExtractFileName(fnList.Strings[i8]));
                If CheckBoxDupWholeFilename.Checked then begin If s1=sFilename then b2:=true; end else begin
                  i9:=Pos(sFilename,s1); i10:=Pos(s1,sFilename); If (i9>0)or(i10>0) then b2:=true; end;
                inc(i8);
              end;
              b1:=b2; fnList.Add(sFilename);
            end;

          end else begin // BEGIN: Selection cause of items and/or id3-tag

            If sSongname<>'*' then begin // filtermask for songnames
              s1:=Trim(ListViewLeft.Items[i1].Caption);
              If not CheckBoxSongnameCaseSensitive.Checked then s1:=LowerCase(s1);
              If (LowerCase(sSongname)='<none>')or(sSongname='') then begin If s1<>'' then b1:=false; end else If Pos(sSongname,s1)<1 then b1:=false;
            end;
            If (sFilename<>'*')and(b1) then begin // filtermask for filenames
              s1:=Trim(ListViewLeft.Items[i1].SubItems[0]);
              If not CheckBoxFilenameCaseSensitive.Checked then s1:=LowerCase(s1);
              If (LowerCase(sFilename)='<none>')or(sFilename='') then begin If s1<>'' then b1:=false; end else If Pos(sFilename,s1)<1 then b1:=false;
            end;
            If not RadioButtonID3TagIgnore.Checked then begin MpegFile1:=TMpegAudio.Create; Try // not "ignore ID3-Tag"
              MpegFile1.FileName:=ListViewLeft.Items[i1].SubItems[0];
              If (RadioButtonID3TagWithHeader.Checked)and(b1) then begin // only songs with ID3-Tag header
                If not MpegFile1.IsValid then b1:=false else If not MpegFile1.isTagged then b1:=false;
              end else
              If (RadioButtonID3TagWithoutHeader.Checked)and(b1) then begin // only songs whit no ID3-Tag header
                If not MpegFile1.IsValid then b1:=false else If MpegFile1.isTagged then b1:=false;
              end else
              If (RadioButtonID3TagFilter.Checked)and(b1) then begin // only songs which equals to this ID3-Tag filtermask:
                If b1 then If MpegFile1.IsValid then If MpegFile1.isTagged then begin
                  If (Trim(ComboBoxTagArtist.Text)<>'*')and(b1) then begin // ID3-Tag: Artist
                    If (LowerCase(Trim(ComboBoxTagArtist.Text))='<none>')or(Trim(ComboBoxTagArtist.Text)='') then begin
                      If (MpegFile1.Artist<>'')or(MpegFile1.Artist<>'[notag]')or(MpegFile1.Artist<>'[no tag]') then b1:=false;
                    end else If Pos(LowerCase(ComboBoxTagArtist.Text),LowerCase(MpegFile1.Artist))<1 then b1:=false;
                  end;
                  If (Trim(ComboBoxTagTitle.Text)<>'*')and(b1) then begin // ID3-Tag: Title
                    If (LowerCase(Trim(ComboBoxTagTitle.Text))='<none>')or(Trim(ComboBoxTagTitle.Text)='') then begin
                      If (MpegFile1.Title<>'')or(MpegFile1.Title<>'[notag]')or(MpegFile1.Title<>'[no tag]') then b1:=false;
                    end else If Pos(LowerCase(ComboBoxTagTitle.Text),LowerCase(MpegFile1.Title))<1 then b1:=false;
                  end;
                  If (Trim(ComboBoxTagAlbum.Text)<>'*')and(b1) then begin // ID3-Tag: Album
                    If (LowerCase(Trim(ComboBoxTagAlbum.Text))='<none>')or(Trim(ComboBoxTagAlbum.Text)='') then begin
                      If (MpegFile1.Album<>'')or(MpegFile1.Album<>'[notag]')or(MpegFile1.Album<>'[no tag]') then b1:=false;
                    end else If Pos(LowerCase(ComboBoxTagAlbum.Text),LowerCase(MpegFile1.Album))<1 then b1:=false;
                  end;
                  If (Trim(ComboBoxTagYear.Text)<>'*')and(b1) then begin // ID3-Tag: Year
                    If (LowerCase(Trim(ComboBoxTagYear.Text))='<none>')or(Trim(ComboBoxTagYear.Text)='') then begin
                      If (MpegFile1.Year<>'')or(MpegFile1.Year<>'[notag]')or(MpegFile1.Year<>'[no tag]') then b1:=false;
                    end else If Pos(LowerCase(ComboBoxTagYear.Text),LowerCase(MpegFile1.Year))<1 then b1:=false;
                  end;
                  If (Trim(ComboBoxTagTrack.Text)<>'*')and(b1) then begin // ID3-Tag: Genre
                    Val(Trim(ComboBoxTagTrack.Text),i8,i9); If i9=0 then begin If i8<>MpegFile1.Track then b1:=false; end else b1:=false;
                  end;
                  If (Trim(ComboBoxTagGenre.Text)<>'*')and(b1) then begin // ID3-Tag: Genre
                    If Pos(LowerCase(ComboBoxTagGenre.Text),LowerCase(MpegFile1.GenreStr))<1 then b1:=false;
                  end;
                  If (Trim(ComboBoxTagComment.Text)<>'*')and(b1) then begin // ID3-Tag: Comment
                    If (LowerCase(Trim(ComboBoxTagComment.Text))='<none>')or(Trim(ComboBoxTagComment.Text)='') then begin
                      If (MpegFile1.Comment<>'')or(MpegFile1.Comment<>'[notag]')or(MpegFile1.Comment<>'[no tag]') then b1:=false;
                    end else If Pos(LowerCase(ComboBoxTagComment.Text),LowerCase(MpegFile1.Comment))<1 then b1:=false;
                  end;
                end else b1:=false;
              end;
            Finally MpegFile1.Free; end; end;

          end; // END: Selection cause of items and/or id3-tag

          If b1 then Self.ListViewLeft.Items[i1].Selected:=true;
        end;
      Except end; // End-For

      If CheckBoxOnlyDuplicates.Checked then begin snList.Free; fnList.Free; end;
    Finally Self.GaugePanel.Visible:=false; Screen.Cursor:=crDefault; end;
  Finally Free; end;
end;

procedure TMainForm.ListViewRight_OnDblClick(Sender: TObject);
begin
  If ButtonPlay.Enabled then begin
    If MPEGPlayer.Paused then begin MPEGPlayer.Stop; MPEGPlayer.Close; end;
    ButtonPlay_OnClick(nil);
  end;
end;

procedure TMainForm.ButtonSong_OnClick(Sender: TObject);
var li1: TListItem;
begin
  If PlayingListItem<>nil then begin ListViewRight.Selected:=PlayingListItem; ListViewRight.Selected.MakeVisible(false); end;
  ButtonSelNone_OnClick(nil);  
  li1:=ListViewLeft.FindCaption(0,ButtonSong.Hint,false,true,false);
  If li1<>nil then begin ListViewLeft.Selected:=li1; ListViewLeft.Selected.MakeVisible(false); end;
end;

procedure TMainForm.PMlRemSel_OnClick(Sender: TObject);
var i1: integer;
begin
  If (IsNowProtected)and(NeedPwForOpenPlaylist) then begin MsgNotAllowed; Exit; end;
  For i1:=pred(ListViewLeft.Items.Count) downto 0 do If ListViewLeft.Items[i1].Selected then ListViewLeft.Items[i1].Delete;
end;

procedure TMainForm.PMlRemAll_OnClick(Sender: TObject);
begin
  If (IsNowProtected)and(NeedPwForOpenPlaylist) then begin MsgNotAllowed; Exit; end;
  If MessageDlg('Remove all songs from avaible songlist ?',mtConfirmation,[mbYes]+[mbCancel],0)=idYes then ListViewLeft.Items.Clear;
end;

procedure TMainForm.ButtonPlay_OnClick(Sender: TObject);
var i1: integer; s1: string; 
begin
  If (IsNowProtected)and(NeedPwForPlay) then begin MsgNotAllowed; Exit; end;
  Try
    ButtonStop.Enabled:=true;
    ButtonPause.Enabled:=true;
    If MPEGPlayer.Paused then MPEGPlayer.Paused:=false else begin
      If MPEGPlayer.Mode=plmPlaying then begin MPEGPlayer.Stop; MPEGPlayer.Close; end;
      PlayingListItem:=ListViewRight.Selected;
      If PlayingListItem<>nil then If FileExists(ListViewRight.Selected.SubItems[0]) then begin
        LastSongs.Add(PlayingListItem.SubItems[0]);
        ListViewRight.Update; ListViewLeft.Update; ListView_OnChange(nil,nil,ctState);
        MPEGPlayer.StreamName:=PlayingListItem.SubItems[0];
        MPEGPlayer.Open; MPEGPlayer.Play;
        s1:=PlayingListItem.Caption;
        ButtonSong.Hint:=s1;
        For i1:=Length(s1) downto 1 do If s1[i1]='&' then insert('&',s1,i1);
        ButtonSong.Caption:=s1; ButtonSong.Enabled:=true;
        LabelInfo.Caption:=IntToStr(MPEGPlayer.BitRate div 1000)+' KB / '+IntToStr(MPEGPlayer.Frequency)+' Hz';
        LabelTotal.Caption:=MilliSecondsToString(MPEGPlayer.Length);
        Scrollbar.Position:=0; Scrollbar.Max:=MPEGPlayer.Length;
        If PeakPanel2.Visible then begin Vumeter.Start; PeakTimer_OnTimer(nil); PeakTimer.Enabled:=true; end;
      end;
    end;
  Except end;
end;

procedure TMainForm.ButtonPause_OnClick(Sender: TObject);
begin
  If (IsNowProtected)and(NeedPwForPause) then begin MsgNotAllowed; Exit; end;
  Try
    MPEGPlayer.Paused:=not MPEGPlayer.Paused;
    ButtonPause.Enabled:=not MPEGPlayer.Paused;
  Except end;
end;

procedure TMainForm.ButtonStop_OnClick(Sender: TObject);
begin
  If (IsNowProtected)and(NeedPwForStop) then begin MsgNotAllowed; Exit; end;
  Try
    ButtonStop.Enabled:=false;
    ButtonPause.Enabled:=false;
    ButtonPlay.Enabled:=ListViewRight.Items.Count>0;
    If PeakTimer.Enabled then begin PeakTimer.Enabled:=false; Vumeter.Stop; end; PeakButtonClear_OnClick(nil);
    If MPEGPlayer.Mode=plmOpened then begin MPEGPlayer.Stop; MPEGPlayer.Close; end;
    ButtonSong.Hint:=''; ButtonSong.Caption:=''; ButtonSong.Enabled:=false;
    LabelInfo.Caption:='-';
    LabelNow.Caption:='-';
    LabelRem.Caption:='-';
    LabelTotal.Caption:='-';
    PlayingListItem:=nil;
    MPEGPlayer.StreamName:='';
    ScrollBar.Position:=0;
  Except end;
end;

procedure TMainForm.ButtonBack_OnClick(Sender: TObject);
var i1: integer; s1, s2: string;
begin
  If (IsNowProtected)and(NeedPwForBack) then begin MsgNotAllowed; Exit; end;
  Try
    i1:=1;
    If ListViewRight.Items[ListViewRight.Selected.Index-1]<>nil then ListViewRight.Selected:=ListViewRight.Items[ListViewRight.Selected.Index-1] else
    If LastSongs.Count>1 then begin
      LastSongs.Delete(pred(LastSongs.Count));
      s1:=LastSongs[pred(LastSongs.Count)];
      If ExpandFileCom(s1,s2)=1 then begin // the file exists!
        If (PlayingListItem<>nil)and(PlayRemoveAfterBack) then begin PlayingListItem.Delete; PlayingListItem:=nil; end; // removes playing song from list
        i1:=2; ListViewRight.Selected:=AddToSongList(1,s1,true,'');
      end else i1:=0;
    end else i1:=0;
    If i1>0 then begin
      If (MPEGPlayer.Paused)or(MPEGPlayer.StreamName>'') then ButtonStop_OnClick(nil);
      If ListViewRight.Selected<>nil then begin
        ListViewRight.Selected.MakeVisible(false); ButtonPlay_OnClick(nil);
        If i1=2 then begin LastSongs.Delete(pred(LastSongs.Count)); ListView_OnChange(nil,nil,ctState); end;
      end;
    end;
  Except end;
end;

procedure TMainForm.ButtonNext_OnClick(Sender: TObject);
begin
  If (IsNowProtected)and(NeedPwForNext) then begin MsgNotAllowed; Exit; end;
  Try
    If ListViewRight.Items.Count>0 then begin
      If ListViewRight.Items[ListViewRight.Selected.Index+1]=nil then begin
        If (ListViewRight.Selected<>nil)and(ListViewRight.Items.Count=1) then begin ButtonRemoveSel_OnClick(nil); MPEGPlayer_OnPlayEnd(nil); end;
      end else begin
        ListViewRight.Selected:=ListViewRight.Items[ListViewRight.Selected.Index+1];
        If (MPEGPlayer.Paused)or(MPEGPlayer.StreamName>'') then ButtonStop_OnClick(nil);
        If ListViewRight.Selected<>nil then begin ListViewRight.Selected.MakeVisible(false); ButtonPlay_OnClick(nil); end;
      end;
    end else MPEGPlayer_OnPlayEnd(nil);
  Except end;
end;       

procedure TMainForm.MPEGPlayer_OnPosUpdate(Pos, Len: Integer);
begin
  If PosPanel2.Visible then begin
    If not PosIsChangingNow then Scrollbar.Position:=MPEGPlayer.CurrentPosition;
    LabelNow.Caption:=MilliSecondsToString(Pos); LabelNow.Update;
    LabelRem.Caption:='-'+MilliSecondsToString(Len-Pos); LabelNow.Update;
  end;    
end;

procedure TMainForm.MPEGPlayer_OnPlayEnd(Sender: TObject);
var i1: integer;
begin
  Try
    If PeakTimer.Enabled then begin PeakTimer.Enabled:=false; Vumeter.Stop;
      PeakLeft.Position:=0; PeakRight.Position:=0; PeakButtonClear_OnClick(nil); end;
    ButtonStop.Enabled:=false;
    ButtonPause.Enabled:=false;
    ButtonPlay.Enabled:=true;
    ButtonSong.Caption:=''; ButtonSong.Enabled:=false; ButtonSong.Hint:='';
    LabelInfo.Caption:='-';
    LabelNow.Caption:='-';
    LabelRem.Caption:='-';
    LabelTotal.Caption:='-';
    MPEGPlayer.StreamName:='';
    ScrollBar.Position:=0;

    Try
      If ButtonRandom.Down then begin // random
        If ListViewRight.Items.Count>1 then begin
          Randomize;
          Repeat i1:=Random(ListViewRight.Items.Count-1); until i1<>PlayingListItem.Index;
          ListViewRight.Selected:=ListViewRight.Items[i1];
        end;
      end else begin // continue
        If ListViewRight.Items.Count>1 then begin
          If ListViewRight.Items[PlayingListItem.Index+1]<>nil then ListViewRight.Selected:=ListViewRight.Items[PlayingListItem.Index+1] else
          If ListViewRight.Items[PlayingListItem.Index-1]<>nil then ListViewRight.Selected:=ListViewRight.Items[PlayingListItem.Index-1];
        end;
      end;
    Except end;
    Try
      If (PlayAutoRemove)and(PlayingListItem<>nil) then PlayingListItem.Delete;
      If ListViewRight.Selected<>nil then begin
        ListViewRight.Selected.MakeVisible(false);
        If PlayAutoStart then ButtonPlay_OnClick(nil);
      end else begin
        PlayingListItem:=nil;
        If (ListViewRight.Items.Count<1)and(ListViewLeft.Items.Count>0)and(PlayAutoRandom) then begin
          ButtonSelNone_OnClick(nil);
          Randomize;
          i1:=Random(ListViewLeft.Items.Count-1);
          ListViewLeft.Selected:=ListViewLeft.Items[i1];
          ListViewLeft.Selected.MakeVisible(false);
          ListViewLeft_OnDblClick(nil);
        end;
      end;
    Except end;
  Except end;  
end;               

procedure TMainForm.PeakTimer_OnTimer(Sender: TObject);
begin
  If Vumeter.Update then begin
    If PeakLeft.Position<>Vumeter.LeftPeak then begin
      If Vumeter.LeftPeak>PeakLeft.Max then PeakLeft.Max:=Vumeter.LeftPeak;
      PeakLeft.Position:=Vumeter.LeftPeak;
      PeakLeft.Update;
    end;
    If PeakRight.Position<>Vumeter.RightPeak then begin
      If Vumeter.RightPeak>PeakRight.Max then PeakRight.Max:=Vumeter.RightPeak;
      PeakRight.Position:=Vumeter.RightPeak;
      PeakRight.Update;
    end;
  end else begin
    PeakLeft.Position:=0; PeakRight.Position:=0;
    PeakButtonClear_OnClick(nil);
    PeakLeft.Update; PeakRight.Update;
  end;   
end;         

procedure TMainForm.PeakButtonClear_OnClick(Sender: TObject);
begin PeakLeft.Max:=0; PeakRight.Max:=0; end;

procedure TMainForm.ScrollBar_OnScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
begin 
  Case ScrollCode of
    scTrack: PosIsChangingNow:=true;
    scEndScroll: begin
                   PosIsChangingNow:=false;
                   If (MPEGPlayer.Mode=plmPlaying)or(MPEGPlayer.Mode=plmPaused) then MPEGPlayer.CurrentPosition:=ScrollPos;
                 end;
  end;
end;

procedure TMainForm.ScrollBar_OnChange(Sender: TObject);
begin ScrollPosLabel.Caption:=IntToStr(GetProcent(Scrollbar.Max,Scrollbar.Position))+'%'; ScrollPosLabel.Update; end;

END.
