{###############################################################################
# Dipesh-MP3yk                                               Delphi-Sourcecode #
################################################################################
# by Sebastian Sauer (Dipesh)                                                  #
#   email:   mail@dipesh.de                                                    #
#   url:     www.dipesh.de                                                     #
# (C) 1999 - freeware, see the licenceagreements in readme.txt                 #
################################################################################
# SAVEHTML.PAS - TSaveHtmlForm                                                 #
# save Playlist as Html-Document                                               #
###############################################################################}

UNIT SaveHtml;

INTERFACE

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TSaveHtmlForm = class(TForm)
    ButtonSave: TBitBtn;
    ButtonCancel: TBitBtn;
    Page: TPageControl;
    TabTitle: TTabSheet;
    TabTable: TTabSheet;
    Panel1: TPanel;
    TableWidthEdit: TEdit;
    Label10: TLabel;
    TableWidthUpDown: TUpDown;
    TableCellspacingEdit: TEdit;
    Label11: TLabel;
    TableCellspacingUpDown: TUpDown;
    TableCellpaddingEdit: TEdit;
    Label12: TLabel;
    TableCellpaddingUpDown: TUpDown;
    TableBorderEdit: TEdit;
    Label9: TLabel;
    TableBorderUpDown: TUpDown;
    Panel2: TPanel;
    TableAlignComboBox: TComboBox;
    TableValignComboBox: TComboBox;
    Label2: TLabel;
    Label1: TLabel;
    LabelFile: TLabel;
    TabColors: TTabSheet;
    Panel4: TPanel;
    MainTextcolorButton: TButton;
    MainBackcolorButton: TButton;
    MainColorsPanel: TPanel;
    EditTitle: TEdit;
    ComboBoxCaptionSize: TComboBox;
    Label3: TLabel;
    ComboBoxCaptionAlign: TComboBox;
    Label4: TLabel;
    CheckBoxCaption: TCheckBox;
    Label5: TLabel;
    TableTextcolorButton: TButton;
    TableBackcolorButton: TButton;
    TableColorsPanel: TPanel;
    HeaderTextcolorButton: TButton;
    HeaderBackcolorButton: TButton;
    HeaderColorPanel: TPanel;
    CheckBoxShowHeader: TCheckBox;
    Label6: TLabel;
    ColorDialog: TColorDialog;
    procedure OnCreate(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    procedure ColorButton_OnClick(Sender: TObject);
  end;

var SaveHtmlForm: TSaveHtmlForm;

IMPLEMENTATION

uses Main;

{$R *.DFM}

procedure TSaveHtmlForm.OnCreate(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
  ButtonSave.Glyph:=MainForm.ButtonSave.Glyph;
  MainForm.ImageListBtn.GetBitmap(0,ButtonCancel.Glyph);
  ComboBoxCaptionSize.ItemIndex:=0; ComboBoxCaptionAlign.ItemIndex:=1;
  TableAlignComboBox.ItemIndex:=1; TableValignComboBox.ItemIndex:=1;
  Page.ActivePage:=TabTitle;
end;

procedure TSaveHtmlForm.OnActivate(Sender: TObject);
begin Screen.Cursor:=crDefault; end;            

procedure TSaveHtmlForm.ColorButton_OnClick(Sender: TObject);
begin
  If Sender=MainTextcolorButton then ColorDialog.Color:=MainColorsPanel.Font.Color else
  If Sender=MainBackcolorButton then ColorDialog.Color:=MainColorsPanel.Color else
  If Sender=TableTextcolorButton then ColorDialog.Color:=TableColorsPanel.Font.Color else
  If Sender=TableBackcolorButton then ColorDialog.Color:=TableColorsPanel.Color else
  If Sender=HeaderTextcolorButton then ColorDialog.Color:=HeaderColorPanel.Font.Color else
  If Sender=HeaderBackcolorButton then ColorDialog.Color:=HeaderColorPanel.Color else Exit;
  If ColorDialog.Execute then begin
    If Sender=MainTextcolorButton then MainColorsPanel.Font.Color:=ColorDialog.Color else
    If Sender=MainBackcolorButton then MainColorsPanel.Color:=ColorDialog.Color else
    If Sender=TableTextcolorButton then TableColorsPanel.Font.Color:=ColorDialog.Color else
    If Sender=TableBackcolorButton then TableColorsPanel.Color:=ColorDialog.Color else
    If Sender=HeaderTextcolorButton then HeaderColorPanel.Font.Color:=ColorDialog.Color else
    If Sender=HeaderBackcolorButton then HeaderColorPanel.Color:=ColorDialog.Color;
  end;
end;

END.
