{###############################################################################
# Dipesh-MP3yk                                               Delphi-Sourcecode #
################################################################################
# by Sebastian Sauer (Dipesh)                                                  #
#   email:   mail@dipesh.de                                                    #
#   url:     www.dipesh.de                                                     #
# (C) 1999 - freeware, see the licenceagreements in readme.txt                 #
################################################################################
# SELGROUP.PAS - TSelGroupForm                                                 #
# Select a group from songs in the right Playlist                              #
###############################################################################}

UNIT SelGroup;

INTERFACE

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, ComCtrls, Buttons, 
     MPGTools;

type
  TSelGroupForm = class(TForm)
    ButtonSelectNow: TBitBtn;
    ButtonCancel: TBitBtn;
    Page: TPageControl;
    TabGeneral: TTabSheet;
    TabID3tag: TTabSheet;
    GroupBox1: TGroupBox;
    GroupBox3: TGroupBox;
    ScrollBox: TScrollBox;
    Panel1: TPanel;
    RadioButtonID3TagIgnore: TRadioButton;
    RadioButtonID3TagFilter: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label14: TLabel;
    RadioButtonID3TagWithHeader: TRadioButton;
    RadioButtonID3TagWithoutHeader: TRadioButton;
    ComboBoxTagArtist: TComboBox;
    ComboBoxTagTitle: TComboBox;
    ComboBoxTagAlbum: TComboBox;
    ComboBoxTagYear: TComboBox;
    ComboBoxTagTrack: TComboBox;
    ComboBoxTagGenre: TComboBox;
    ComboBoxTagComment: TComboBox;
    CheckBoxClear: TCheckBox;
    TabItems: TTabSheet;
    GroupBox2: TGroupBox;
    GroupBox4: TGroupBox;
    ComboBoxSongname: TComboBox;
    CheckBoxSongnameCaseSensitive: TCheckBox;
    GroupBox5: TGroupBox;
    ComboBoxFilename: TComboBox;
    CheckBoxFilenameCaseSensitive: TCheckBox;
    CheckBoxOnlyDuplicates: TCheckBox;
    GroupBoxCheck: TGroupBox;
    CheckBoxDupSongname: TCheckBox;
    CheckBoxDupFilename: TCheckBox;
    CheckBoxDupCaseSensitive: TCheckBox;
    CheckBoxDupIgnoreSpecials: TCheckBox;
    CheckBoxDupIgnoreNrs: TCheckBox;
    CheckBoxDupWholeSongname: TCheckBox;
    CheckBoxDupWholeFilename: TCheckBox;
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnCreate(Sender: TObject);
    procedure CheckBoxDuplicates_OnClick(Sender: TObject);
    procedure ButtonSelectNow_OnClick(Sender: TObject);
  end;

var SelGroupForm: TSelGroupForm;

const AktiveTabInSelPage: integer = 0;

IMPLEMENTATION

uses Main;

{$R *.DFM}

procedure TSelGroupForm.OnClose(Sender: TObject; var Action: TCloseAction);
begin AktiveTabInSelPage:=Page.ActivePage.PageIndex; end;

procedure TSelGroupForm.OnCreate(Sender: TObject);
var i1: integer;
begin
  MainForm.ImageListBtn.GetBitmap(1,ButtonSelectNow.Glyph);
  MainForm.ImageListBtn.GetBitmap(0,ButtonCancel.Glyph);
  Page.ActivePage:=Page.Pages[AktiveTabInSelPage];
  ComboBoxTagGenre.ItemIndex:=0;
  For i1:=0 to MaxStyles do ComboBoxTagGenre.Items.Add(MusicStyle[i1]);
end;   

procedure TSelGroupForm.CheckBoxDuplicates_OnClick(Sender: TObject);
begin
  GroupBoxCheck.Visible:=CheckBoxOnlyDuplicates.Checked;
  TabItems.TabVisible:=not CheckBoxOnlyDuplicates.Checked;
  TabID3tag.TabVisible:=not CheckBoxOnlyDuplicates.Checked;
end;

procedure TSelGroupForm.ButtonSelectNow_OnClick(Sender: TObject);
begin
  If (CheckBoxOnlyDuplicates.Checked)and((not CheckBoxDupSongname.Checked)and(not CheckBoxDupFilename.Checked)) then
    If (not CheckBoxDupSongname.Checked)and(not CheckBoxDupFilename.Checked) then begin
      MessageDlg('Not given what to look for: songname or filename?',mtWarning,[mbOk],0);
      Exit;
    end;
  ModalResult:=mrOk;
end;

END.
