{###############################################################################
# Dipesh-MP3yk                                               Delphi-Sourcecode #
################################################################################
# by Sebastian Sauer (Dipesh)                                                  #
#   email:   mail@dipesh.de                                                    #
#   url:     www.dipesh.de                                                     #
# (C) 1999 - freeware, see the licenceagreements in readme.txt                 #
################################################################################
# SETTINGS.PAS - TSettingsForm                                                 #
# Configure the settings.                                                      #
###############################################################################}

UNIT Settings;

INTERFACE

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, ComCtrls, Buttons, MPEGPlay;

type
  TSettingsForm = class(TForm)
    Page: TPageControl;
    TabPlayer: TTabSheet;
    TabPassword: TTabSheet;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    CheckBoxAutoRemove: TCheckBox;
    CheckBoxAutoRandom: TCheckBox;
    ComboBoxPriority: TComboBox;
    CheckBoxUseID3Tags: TCheckBox;
    CheckBoxAutoStart: TCheckBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    EditPassword: TEdit;
    CheckBoxExit: TCheckBox;
    CheckBoxOpenPlaylistfile: TCheckBox;
    CheckBoxPause: TCheckBox;
    CheckBoxPlay: TCheckBox;
    CheckBoxStop: TCheckBox;
    CheckBoxBack: TCheckBox;
    CheckBoxNext: TCheckBox;
    CheckBoxAddSel: TCheckBox;
    ButtonSave: TBitBtn;
    ButtonCancel: TBitBtn;
    TabMain: TTabSheet;
    CheckBoxSavePlaylistfile: TCheckBox;
    CheckBoxAddAll: TCheckBox;
    CheckBoxRemoveSel: TCheckBox;
    CheckBoxRemoveAll: TCheckBox;
    GroupBox3: TGroupBox;
    Label5: TLabel;
    ComboBoxwindowstate: TComboBox;
    TabStyle: TTabSheet;
    GroupBox4: TGroupBox;
    FontDialog: TFontDialog;
    ColorDialog: TColorDialog;
    Label4: TLabel;
    CheckBoxZoom: TCheckBox;
    CheckBoxAddDir: TCheckBox;
    CheckBoxCenter: TCheckBox;
    ButtonMainFont: TButton;
    ButtonMainColor: TButton;
    ButtonFontLeftList: TButton;
    ButtonLeftListColor: TButton;
    ButtonFontRightList: TButton;
    ButtonRightListColor: TButton;
    ButtonHlFontColor: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    CheckBoxDragNDrop: TCheckBox;
    CheckBoxViewID3tag: TCheckBox;
    CheckBoxEditID3tag: TCheckBox;
    GroupBox5: TGroupBox;
    CheckBoxLeftlistGridlines: TCheckBox;
    CheckBoxLeftlistHeader: TCheckBox;
    CheckBoxLeftlistTitle: TCheckBox;
    GroupBox6: TGroupBox;
    CheckBoxRightlistGridlines: TCheckBox;
    CheckBoxRightlistHeader: TCheckBox;
    CheckBoxRightlistTitle: TCheckBox;
    CheckBoxLeftHottrack: TCheckBox;
    CheckBoxRightHottrack: TCheckBox;
    GroupBox7: TGroupBox;
    AutoopenPlaylistEdit: TEdit;
    CheckBoxAutoopenPlaylistSave: TCheckBox;
    AutoopenPlaylistButton: TButton;
    CheckBoxSingleInstance: TCheckBox;
    OpenDialog: TOpenDialog;
    Label6: TLabel;
    EditPeakUpdate: TEdit;
    UpDownPeakUpdate: TUpDown;
    Label11: TLabel;
    CheckBoxBackRemove: TCheckBox;
    Label12: TLabel;
    Label13: TLabel;
    EditPosUpdate: TEdit;
    UpDownPosUpdate: TUpDown;
    Label14: TLabel;
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnCreate(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    procedure ButtonSave_OnClick(Sender: TObject);
    procedure AutoopenPlaylistButton_OnClick(Sender: TObject);
    procedure ProfilePanels_OnMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Font_OnClick(Sender: TObject);
    procedure Color_OnClick(Sender: TObject);
  end;

var SettingsForm: TSettingsForm;

const AktiveTabInPage: integer = 0;

IMPLEMENTATION

uses Main;

{$R *.DFM}     

procedure TSettingsForm.OnClose(Sender: TObject; var Action: TCloseAction);
begin AktiveTabInPage:=Page.ActivePage.PageIndex; end;

procedure TSettingsForm.OnCreate(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
  Page.ActivePage:=Page.Pages[AktiveTabInPage];
  ButtonSave.Glyph:=MainForm.ButtonSave.Glyph;
  MainForm.ImageListBtn.GetBitmap(0,ButtonCancel.Glyph);
  // Playing
  With MainForm.MPEGPlayer do Case PlayerPriority of Idle: ComboBoxPriority.ItemIndex:=0; Lowest: ComboBoxPriority.ItemIndex:=1;
    BelowNormal: ComboBoxPriority.ItemIndex:=2; Normal: ComboBoxPriority.ItemIndex:=3; AboveNormal: ComboBoxPriority.ItemIndex:=4;
    Highest: ComboBoxPriority.ItemIndex:=5; TimeCritical: ComboBoxPriority.ItemIndex:=6; end;
  CheckBoxAutoStart.Checked:=PlayAutoStart;
  CheckBoxUseID3Tags.Checked:=PlayUseID3Tags;
  CheckBoxAutoRemove.Checked:=PlayAutoRemove;
  CheckBoxAutoRandom.Checked:=PlayAutoRandom;
  CheckBoxBackRemove.Checked:=PlayRemoveAfterBack;
  AutoopenPlaylistEdit.Text:=PlayThisPlaylistfileOnStart;
  CheckBoxAutoopenPlaylistSave.Checked:=SaveLastOpenPlaylistfile;
  // Passwordprotection
  EditPassword.Text:=PasswordStr;
  CheckBoxExit.Checked:=NeedPwForExit;
  CheckBoxOpenPlaylistfile.Checked:=NeedPwForOpenPlaylist;
  CheckBoxSavePlaylistfile.Checked:=NeedPwForSavePlaylist;
  CheckBoxAddDir.Checked:=NeedPwForAddDir;
  CheckBoxAddSel.Checked:=NeedPwForAddSel;
  CheckBoxAddAll.Checked:=NeedPwForAddAll;
  CheckBoxRemoveSel.Checked:=NeedPwForRemoveSel;
  CheckBoxRemoveAll.Checked:=NeedPwForRemoveAll;
  CheckBoxPlay.Checked:=NeedPwForPlay;
  CheckBoxPause.Checked:=NeedPwForPause;
  CheckBoxStop.Checked:=NeedPwForStop;
  CheckBoxBack.Checked:=NeedPwForBack;
  CheckBoxNext.Checked:=NeedPwForNext;
  CheckBoxViewID3tag.Checked:=MeedPwForViewID3Tag;
  CheckBoxEditID3tag.Checked:=MeedPwForEditID3Tag;
  // Main
  CheckBoxSingleInstance.Checked:=singleinstance;
  If (mainwindowstate>=0)and(mainwindowstate<4) then ComboBoxwindowstate.ItemIndex:=mainwindowstate else ComboBoxwindowstate.ItemIndex:=4;
  CheckBoxZoom.Checked:=mainzoom;
  CheckBoxCenter.Checked:=maincenter;
  CheckBoxDragNDrop.Checked:=MainForm.ListViewLeft.DragMode=dmAutomatic;
  CheckBoxLeftHottrack.Checked:=MainForm.ListViewLeft.HotTrack;
  CheckBoxLeftlistGridlines.Checked:=MainForm.ListViewLeft.GridLines;
  CheckBoxLeftlistHeader.Checked:=MainForm.ListViewLeft.ShowColumnHeaders;
  CheckBoxLeftlistTitle.Checked:=MainForm.PanelLeftCaption.Visible;
  CheckBoxRightHottrack.Checked:=MainForm.ListViewRight.HotTrack;
  CheckBoxRightlistGridlines.Checked:=MainForm.ListViewRight.GridLines;
  CheckBoxRightlistHeader.Checked:=MainForm.ListViewRight.ShowColumnHeaders;
  CheckBoxRightlistTitle.Checked:=MainForm.PanelRightCaption.Visible;
  // Style
  UpDownPosUpdate.Position:=PosUpdateTime; EditPosUpdate.Text:=IntToStr(UpDownPosUpdate.Position);
  UpDownPeakUpdate.Position:=PeakLevelUpdateTime; EditPeakUpdate.Text:=IntToStr(UpDownPeakUpdate.Position);
end;

procedure TSettingsForm.OnActivate(Sender: TObject);
begin Screen.Cursor:=crDefault; end; 

procedure TSettingsForm.ButtonSave_OnClick(Sender: TObject);
var b1: boolean; textfile1: textfile;
begin
  If not FileExists(IniFileCom) then If MessageDlg('Can''t find Inifile.'+#13+'Create a new one?',mtConfirmation,[mbYes]+[mbCancel],0)<>idYes then Exit;
  AssignFile(textfile1,IniFileCom); {$I-} Rewrite(textfile1); {$I+}
  If IoResult<>0 then begin b1:=false; MessageDlg('Can''t open inifile to write settings.',mtError,[mbOk],0) end else begin
    mainleft:=-1; maintop:=-1; mainwidth:=-1; mainheight:=-1; mainsplitter1:=-1; mainsplitter2:=-1; 
    b1:=true; ModalResult:=mrOk;
    // -> [Playing]
    WriteLn(textfile1,'[Playing]');
    WriteLn(textfile1,'Priority='+IntToStr(ComboBoxPriority.ItemIndex));
      With MainForm.MPEGPlayer do Case ComboBoxPriority.ItemIndex of 0: PlayerPriority:=Idle; 1: PlayerPriority:=Lowest;
        2: PlayerPriority:=BelowNormal; 3: PlayerPriority:=Normal; 4: PlayerPriority:=AboveNormal;
        5: PlayerPriority:=Highest; 6: PlayerPriority:=TimeCritical; end;
      PlayAutoStart:=CheckBoxAutoStart.Checked;
    WriteLn(textfile1,'Autostart='+BoolToStr(PlayAutoStart));
      PlayUseID3Tags:=CheckBoxUseID3Tags.Checked;
    WriteLn(textfile1,'use ID3-Tag''s='+BoolToStr(PlayUseID3Tags));
      PlayAutoRemove:=CheckBoxAutoRemove.Checked;
    WriteLn(textfile1,'Autoremove='+BoolToStr(PlayAutoRemove));
      PlayAutoRandom:=CheckBoxAutoRandom.Checked;
    WriteLn(textfile1,'Autorandom='+BoolToStr(PlayAutoRandom));
      PlayRemoveAfterBack:=CheckBoxBackRemove.Checked;
    WriteLn(textfile1,'RemoveAfterBack='+BoolToStr(PlayRemoveAfterBack));
      PlayThisPlaylistfileOnStart:=Trim(AutoopenPlaylistEdit.Text);
    WriteLn(textfile1,'AutoopenPlaylist='+PlayThisPlaylistfileOnStart);
      SaveLastOpenPlaylistfile:=CheckBoxAutoopenPlaylistSave.Checked;
    WriteLn(textfile1,'AutoopenPlaylistSave='+BoolToStr(SaveLastOpenPlaylistfile));
    WriteLn(textfile1);
    // -> [Pw]
    WriteLn(textfile1,'[Pw]');
      PasswordStr:=Trim(EditPassword.Text);
    WriteLn(textfile1,'Password='+PasswordStr);
      NeedPwForExit:=CheckBoxExit.Checked;
    WriteLn(textfile1,'Exit='+BoolToStr(NeedPwForExit));
      NeedPwForOpenPlaylist:=CheckBoxOpenPlaylistfile.Checked;
    WriteLn(textfile1,'Open Playlistfile='+BoolToStr(NeedPwForOpenPlaylist));
      NeedPwForSavePlaylist:=CheckBoxSavePlaylistfile.Checked;
    WriteLn(textfile1,'Save Playlistfile='+BoolToStr(NeedPwForSavePlaylist));
      NeedPwForAddDir:=CheckBoxAddDir.Checked;
    WriteLn(textfile1,'Add dir='+BoolToStr(NeedPwForAddDir));
      MeedPwForViewID3Tag:=CheckBoxViewID3tag.Checked;
    WriteLn(textfile1,'view ID3-Tag='+BoolToStr(MeedPwForViewID3Tag));
      MeedPwForEditID3Tag:=CheckBoxEditID3tag.Checked;
    WriteLn(textfile1,'edit ID3-Tag='+BoolToStr(MeedPwForEditID3Tag));
      NeedPwForAddSel:=CheckBoxAddSel.Checked;
    WriteLn(textfile1,'AddSel='+BoolToStr(NeedPwForAddSel));
      NeedPwForAddAll:=CheckBoxAddAll.Checked;
    WriteLn(textfile1,'AddAll='+BoolToStr(NeedPwForAddAll));
      NeedPwForRemoveSel:=CheckBoxRemoveSel.Checked;
    WriteLn(textfile1,'RemoveSel='+BoolToStr(NeedPwForRemoveSel));
      NeedPwForRemoveAll:=CheckBoxRemoveAll.Checked;
    WriteLn(textfile1,'RemoveAll='+BoolToStr(NeedPwForRemoveAll));
      NeedPwForPlay:=CheckBoxPlay.Checked;
    WriteLn(textfile1,'Play='+BoolToStr(NeedPwForPlay));
      NeedPwForPause:=CheckBoxPause.Checked;
    WriteLn(textfile1,'Pause='+BoolToStr(NeedPwForPause));
      NeedPwForStop:=CheckBoxStop.Checked;
    WriteLn(textfile1,'Stop='+BoolToStr(NeedPwForStop));
      NeedPwForBack:=CheckBoxBack.Checked;
    WriteLn(textfile1,'Back='+BoolToStr(NeedPwForBack));
      NeedPwForNext:=CheckBoxNext.Checked;
    WriteLn(textfile1,'Next='+BoolToStr(NeedPwForNext));
    WriteLn(textfile1);
    // -> [Main]
    WriteLn(textfile1,'[Main]');
      singleinstance:=CheckBoxSingleInstance.Checked;
    WriteLn(textfile1,'singleinstance='+BoolToStr(singleinstance));
      mainwindowstate:=ComboBoxwindowstate.ItemIndex;
    WriteLn(textfile1,'state='+IntToStr(mainwindowstate));
      mainzoom:=CheckBoxZoom.Checked;
    WriteLn(textfile1,'zoom='+BoolToStr(mainzoom));
      maincenter:=CheckBoxCenter.Checked;
    WriteLn(textfile1,'center='+BoolToStr(maincenter));
      With MainForm do If CheckBoxDragNDrop.Checked then begin ListViewLeft.DragMode:=dmAutomatic; ListViewRight.DragMode:=dmAutomatic; end
      else begin ListViewLeft.DragMode:=dmManual; ListViewRight.DragMode:=dmManual;  end;
    WriteLn(textfile1,'dragdrop='+BoolToStr(CheckBoxDragNDrop.Checked));
      MainForm.ListViewLeft.HotTrack:=CheckBoxLeftHottrack.Checked;
    WriteLn(textfile1,'leftlisthottrack='+BoolToStr(CheckBoxLeftHottrack.Checked));
      MainForm.ListViewLeft.GridLines:=CheckBoxLeftlistGridlines.Checked;
    WriteLn(textfile1,'leftlistgridlines='+BoolToStr(CheckBoxLeftlistGridlines.Checked));
      MainForm.ListViewLeft.ShowColumnHeaders:=CheckBoxLeftlistHeader.Checked;
    WriteLn(textfile1,'leftlistheaders='+BoolToStr(CheckBoxLeftlistHeader.Checked));
      MainForm.PanelLeftCaption.Visible:=CheckBoxLeftlistTitle.Checked;
    WriteLn(textfile1,'leftlisttitles='+BoolToStr(CheckBoxLeftlistTitle.Checked));
      MainForm.ListViewRight.HotTrack:=CheckBoxRightHottrack.Checked;
    WriteLn(textfile1,'rightlisthottrack='+BoolToStr(CheckBoxRightHottrack.Checked));
      MainForm.ListViewRight.GridLines:=CheckBoxRightlistGridlines.Checked;
    WriteLn(textfile1,'rightlistgridlines='+BoolToStr(CheckBoxRightlistGridlines.Checked));
      MainForm.ListViewRight.ShowColumnHeaders:=CheckBoxRightlistHeader.Checked;
    WriteLn(textfile1,'rightlistheaders='+BoolToStr(CheckBoxRightlistHeader.Checked));
      MainForm.PanelRightCaption.Visible:=CheckBoxRightlistTitle.Checked;
    WriteLn(textfile1,'rightlisttitles='+BoolToStr(CheckBoxRightlistTitle.Checked));
    WriteLn(textfile1);
    // -> [Style]    
    WriteLn(textfile1,'[Style]');
    WriteLn(textfile1,'mainfont='+MainForm.FontToString(MainForm.Font));
    WriteLn(textfile1,'mainbackgrd='+IntToStr(MainForm.Color));
    WriteLn(textfile1,'leftlistfont='+MainForm.FontToString(MainForm.ListViewLeft.Font));
    WriteLn(textfile1,'leftlistbackgrd='+IntToStr(MainForm.ListViewLeft.Color));
    WriteLn(textfile1,'rightlistfont='+MainForm.FontToString(MainForm.ListViewRight.Font));
    WriteLn(textfile1,'rightlistbackgrd='+IntToStr(MainForm.ListViewRight.Color));
    WriteLn(textfile1,'playerfontcolor='+IntToStr(MainForm.ButtonSong.Font.Color));
      PosUpdateTime:=UpDownPosUpdate.Position; MainForm.MPEGPlayer.TimerFreq:=PosUpdateTime;
    WriteLn(textfile1,'scrollandpostime='+IntToStr(PosUpdateTime));
      PeakLevelUpdateTime:=UpDownPeakUpdate.Position; MainForm.PeakTimer.Interval:=PeakLevelUpdateTime;
    WriteLn(textfile1,'peakleveltime='+IntToStr(PeakLevelUpdateTime));
    WriteLn(textfile1);
  end;
  {$I-} CloseFile(textfile1); {$I+}
  If (IoResult<>0)and(b1) then MessageDlg('Can''t save settings.',mtError,[mbOk],0);
end;

procedure TSettingsForm.AutoopenPlaylistButton_OnClick(Sender: TObject);
var s1: string;
begin
  With OpenDialog do begin
    s1:=Trim(AutoopenPlaylistEdit.Text);
    If s1>'' then begin If s1[1]='\' then Delete(s1,1,1);
      If FileExists(StartDir+s1) then s1:=StartDir+s1 else
      If FileExists(StartDir[1]+':\'+s1) then s1:=StartDir[1]+':\'+s1 else s1:=StartDir;
    end else s1:=StartDir;
    InitialDir:=ExtractFilePath(s1); FileName:=ExtractFileName(s1);
    If Execute then begin s1:=ExpandFileName(FileName);
      If Pos(LowerCase(StartDir),LowerCase(s1))=1 then begin
        Delete(s1,1,Length(StartDir)); If s1>'' then If s1[1]<>'\' then s1:='\'+s1;
      end else If Length(s1)>2 then If (UpCase(StartDir[1])=UpCase(s1[1]))and(s1[2]=':') then Delete(s1,1,2);
      AutoopenPlaylistEdit.Text:=s1;
    end;
  end;
end;

procedure TSettingsForm.ProfilePanels_OnMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin With (Sender as TPanel) do Hint:=MainForm.FontToString(Font)+' - '+IntToStr(Color); end;

procedure TSettingsForm.Font_OnClick(Sender: TObject);
begin
  With FontDialog do begin
    If Sender=ButtonMainFont then Font:=MainForm.Font else
    If Sender=ButtonFontLeftList then Font:=MainForm.ListViewLeft.Font else
    If Sender=ButtonFontRightList then Font:=MainForm.ListViewRight.Font else Exit;
    If Execute then begin
      If Sender=ButtonMainFont then MainForm.SetFontOrColor(11,Font,-1) else
      If Sender=ButtonFontLeftList then MainForm.SetFontOrColor(12,Font,-1) else
      If Sender=ButtonFontRightList then MainForm.SetFontOrColor(13,Font,-1);
    end;
  end;
end;

procedure TSettingsForm.Color_OnClick(Sender: TObject);
begin
  With ColorDialog do begin
    If Sender=ButtonMainColor then Color:=MainForm.Color else
    If Sender=ButtonLeftListColor then Color:=MainForm.ListViewLeft.Color else
    If Sender=ButtonRightListColor then Color:=MainForm.ListViewRight.Color else
    If Sender=ButtonHlFontColor then Color:=MainForm.ButtonSong.Font.Color else Exit;
    If Execute then begin
      If Sender=ButtonMainColor then MainForm.SetFontOrColor(101,nil,Color) else
      If Sender=ButtonLeftListColor then MainForm.SetFontOrColor(102,nil,Color) else
      If Sender=ButtonRightListColor then MainForm.SetFontOrColor(103,nil,Color) else
      If Sender=ButtonHlFontColor then MainForm.SetFontOrColor(104,nil,Color);
    end;
  end;
end;
       


END.
