{*****************************************************************************
 *
 *  UOptionsDialog.pas - Dialog to change options
 *
 *  Copyright (c) 1999 Diego Amicabile
 *
 *  Author:     Diego Amicabile
 *  E-mail:     diegoami@yahoo.it
 *  Homepage:   http://www.geocities.com/diegoami
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit UOptionsDialog;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Global, inifiles;

type
  TOptionsDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    DirectoryEdit: TEdit;
    MainHtmlEdit: TEdit;
    JSEdit: TEdit;
    DirectoryStaticText: TStaticText;
    MainHtmlStaticText: TStaticText;
    JavascriptStaticText: TStaticText;
    LeftFrameEdit: TEdit;
    LeftFrameFileName: TStaticText;
    RightFrameEdit: TEdit;
    RightFrameStaticText: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionsDlg: TOptionsDlg;

implementation

{$R *.DFM}

procedure TOptionsDlg.FormCreate(Sender: TObject);
begin
  DirectoryEdit.Text := directory;
  MainhtmlEdit.Text  := MainHtml;
  JSEdit.Text        := JavaScript;
  LeftFrameEdit.Text := LeftFrame;
  RightFrameEdit.Text:= RightFrame;
end;

procedure TOptionsDlg.OKBtnClick(Sender: TObject);
begin
  Directory := DirectoryEdit.Text;
  MainHtml := MainhtmlEdit.Text;
  JavaScript := JSEdit.Text;
  LeftFrame := LeftFrameEdit.Text;
  RightFrame := RightFrameEdit.Text;
  Close;
end;

procedure TOptionsDlg.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

end.
